module kinddefs

  implicit none
  private
! four byte integer (greater than 10e5)
  integer, parameter, public :: system_i4=selected_int_kind(5)
! eight byte integer (greater than 10e10)
  integer, parameter, public :: system_i8=selected_int_kind(10)
  integer, parameter, public :: i8=system_i8
! one byte integer (greater than 10e2)
  integer, parameter, public :: system_i1=selected_int_kind(2)
! two byte integer (greater than 10e3)
  integer, parameter, public :: system_i2=selected_int_kind(3)
! single precision (IEEE 754)
  integer, parameter, public :: system_r4=selected_real_kind(6, 37)
! double precision (IEEE 754)
  integer, parameter, public :: system_r8=selected_real_kind(15, 307)
  integer, parameter, public :: r8=system_r8  ! shorthand for system_r8
  integer, parameter, public :: dp =system_r8 ! default precision
  integer, parameter, public :: jp =system_r8 ! Diagonal LU Jacobian precision
  integer, parameter, public :: dqp=system_r4 ! Delta-q precision
  integer, parameter, public :: odp=system_r4 ! Off-diagonal Jacobian precision

end module kinddefs
