!
! *Do Not edit* this file.  It was generated by the ruby script,
!
! Instead, edit the template file, 'lmpi_app.template', regenerate
! this file (by running ./fortran_template.rb) and commit both
! this generated file and your new template file.
!
! -*- f90 -*- this turns on the emacs f90 mode
! vi:syntax=fortran
!
! Run fortran_template.rb to generate lmpi.F90 from lmpi_app.template
! then check both this file and lmpi_app.F90 into the repository.
! ./fortran_template.rb lmpi_app

module lmpi_app

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

  use kinddefs,    only : dp, system_i1, system_r4, system_r8, system_i8, dqp, &
                          system_i4

  use interp_defs, only : sr, sr_allocated, sendrecv_type,                     &
                          basic_sendrecv_type
  use lmpi,        only : lmpi_id, lmpi_nproc, lmpi_master,                    &
                          lmpi_reduce, lmpi_max, lmpi_bcast,                   &
                          lmpi_reduce_maxloc2
#ifdef HAVE_MPI
  use interp_defs, only : nullify_sendrecv
  use lmpi,        only : lmpi_die, lmpi_comm, lmpi_waitall,                   &
                          sendreq, recvreq,                                    &
                          lmpi_send, lmpi_recv,                                &
                          lmpi_success, lmpi_error, lmpi_status_size,          &
                          lmpi_isend, lmpi_irecv
#endif

  implicit none

  private

#ifdef HAVE_MPI
  include 'mpif.h'
  integer :: nsend, nrecv ! number of send and recv messages
#endif

#ifdef HAVE_MPI
  interface operator(+)
    module procedure add_logical
  end interface

  interface operator(*)
    module procedure multiply_logical_logical
    module procedure multiply_single_logical
    module procedure multiply_double_logical
    module procedure multiply_complex_r4_logical
    module procedure multiply_complex_r8_logical
  end interface

  interface max
    module procedure max_logical
    module procedure max_complex_r4
    module procedure max_complex_r8
  end interface
#endif

  public :: lmpi_collect_res
  interface lmpi_collect_res
    module procedure double_collect_res
    module procedure double_complex_collect_res
  end interface

  public :: lmpi_start_cudampi_xfer
  interface lmpi_start_cudampi_xfer
    module procedure lmpi_start_cudampi_xfer_r4
    module procedure lmpi_start_cudampi_xfer_r8
    module procedure lmpi_start_cudampi_xfer_c4
    module procedure lmpi_start_cudampi_xfer_c8
  end interface

  public :: lmpi_complete_cudampi_xfer
  interface lmpi_complete_cudampi_xfer
    module procedure lmpi_complete_cudampi_xfer_r4
    module procedure lmpi_complete_cudampi_xfer_r8
    module procedure lmpi_complete_cudampi_xfer_c4
    module procedure lmpi_complete_cudampi_xfer_c8
  end interface

  public:: lmpi_set_defaultghostlevel

  public:: lmpi_set_check_xfer01

  public:: lmpi_set_xfer01

  public:: check_size01

  public:: lmpi_set_check_xfer

  public:: lmpi_writeme

  public:: lmpi_getproc_xfer

  public:: lmpi_getindex_xfer

  public:: lmpi_test_xfer

  public:: lmpi_reset_sendrecv

  public :: lmpi_collect_forces
  interface lmpi_collect_forces
    module procedure integr_collect_forces
    module procedure integ8_collect_forces
    module procedure integ1_collect_forces
    module procedure logicl_collect_forces
    module procedure single_collect_forces
    module procedure double_collect_forces
    module procedure cmpxr4_collect_forces
    module procedure cmpxr8_collect_forces
  end interface

  public :: lmpi_collect_mflux
  interface lmpi_collect_mflux
    module procedure integr_collect_mflux
    module procedure integ8_collect_mflux
    module procedure integ1_collect_mflux
    module procedure logicl_collect_mflux
    module procedure single_collect_mflux
    module procedure double_collect_mflux
    module procedure cmpxr4_collect_mflux
    module procedure cmpxr8_collect_mflux
  end interface

  public :: lmpi_xfer
  interface lmpi_xfer
    module procedure integr_vector_xfer
    module procedure integr_matrix_xfer
    module procedure integ8_vector_xfer
    module procedure integ8_matrix_xfer
    module procedure integ1_vector_xfer
    module procedure integ1_matrix_xfer
    module procedure logicl_vector_xfer
    module procedure logicl_matrix_xfer
    module procedure single_vector_xfer
    module procedure single_matrix_xfer
    module procedure double_vector_xfer
    module procedure double_matrix_xfer
    module procedure cmpxr4_vector_xfer
    module procedure cmpxr4_matrix_xfer
    module procedure cmpxr8_vector_xfer
    module procedure cmpxr8_matrix_xfer
  end interface

  public :: lmpi_put
  interface lmpi_put
    module procedure integr_vector_put
    module procedure integr_matrix_put
    module procedure integ8_vector_put
    module procedure integ8_matrix_put
    module procedure integ1_vector_put
    module procedure integ1_matrix_put
    module procedure logicl_vector_put
    module procedure logicl_matrix_put
    module procedure single_vector_put
    module procedure single_matrix_put
    module procedure double_vector_put
    module procedure double_matrix_put
    module procedure cmpxr4_vector_put
    module procedure cmpxr4_matrix_put
    module procedure cmpxr8_vector_put
    module procedure cmpxr8_matrix_put
  end interface

  public :: lmpi_add
  interface lmpi_add
    module procedure integr_vector_add
    module procedure integr_matrix_add
    module procedure integ8_vector_add
    module procedure integ8_matrix_add
    module procedure integ1_vector_add
    module procedure integ1_matrix_add
    module procedure logicl_vector_add
    module procedure logicl_matrix_add
    module procedure single_vector_add
    module procedure single_matrix_add
    module procedure double_vector_add
    module procedure double_matrix_add
    module procedure cmpxr4_vector_add
    module procedure cmpxr4_matrix_add
    module procedure cmpxr8_vector_add
    module procedure cmpxr8_matrix_add
  end interface

  public :: lmpi_start_xfer
  interface lmpi_start_xfer
    module procedure integr_start_vector_xfer
    module procedure integr_start_matrix_xfer
    module procedure integ8_start_vector_xfer
    module procedure integ8_start_matrix_xfer
    module procedure integ1_start_vector_xfer
    module procedure integ1_start_matrix_xfer
    module procedure logicl_start_vector_xfer
    module procedure logicl_start_matrix_xfer
    module procedure single_start_vector_xfer
    module procedure single_start_matrix_xfer
    module procedure double_start_vector_xfer
    module procedure double_start_matrix_xfer
    module procedure cmpxr4_start_vector_xfer
    module procedure cmpxr4_start_matrix_xfer
    module procedure cmpxr8_start_vector_xfer
    module procedure cmpxr8_start_matrix_xfer
  end interface

  public :: lmpi_xfer_fem
  interface lmpi_xfer_fem
    module procedure integr_xfer_fem
    module procedure integ8_xfer_fem
    module procedure integ1_xfer_fem
    module procedure logicl_xfer_fem
    module procedure single_xfer_fem
    module procedure double_xfer_fem
    module procedure cmpxr4_xfer_fem
    module procedure cmpxr8_xfer_fem
  end interface

  public :: lmpi_complete_xfer
  interface lmpi_complete_xfer
    module procedure integr_complete_vector_xfer
    module procedure integr_matrix_complete_xfer
    module procedure integ8_complete_vector_xfer
    module procedure integ8_matrix_complete_xfer
    module procedure integ1_complete_vector_xfer
    module procedure integ1_matrix_complete_xfer
    module procedure logicl_complete_vector_xfer
    module procedure logicl_matrix_complete_xfer
    module procedure single_complete_vector_xfer
    module procedure single_matrix_complete_xfer
    module procedure double_complete_vector_xfer
    module procedure double_matrix_complete_xfer
    module procedure cmpxr4_complete_vector_xfer
    module procedure cmpxr4_matrix_complete_xfer
    module procedure cmpxr8_complete_vector_xfer
    module procedure cmpxr8_matrix_complete_xfer
  end interface

  public :: lmpi_sta_xfer
  interface lmpi_sta_xfer
    module procedure integr_sta_vector_xfer
    module procedure integr_sta_matrix_xfer
    module procedure integ8_sta_vector_xfer
    module procedure integ8_sta_matrix_xfer
    module procedure integ1_sta_vector_xfer
    module procedure integ1_sta_matrix_xfer
    module procedure logicl_sta_vector_xfer
    module procedure logicl_sta_matrix_xfer
    module procedure single_sta_vector_xfer
    module procedure single_sta_matrix_xfer
    module procedure double_sta_vector_xfer
    module procedure double_sta_matrix_xfer
    module procedure cmpxr4_sta_vector_xfer
    module procedure cmpxr4_sta_matrix_xfer
    module procedure cmpxr8_sta_vector_xfer
    module procedure cmpxr8_sta_matrix_xfer
  end interface

  public :: lmpi_end_xfer
  interface lmpi_end_xfer
    module procedure integr_end_vector_xfer
    module procedure integr_matrix_end_xfer
    module procedure integ8_end_vector_xfer
    module procedure integ8_matrix_end_xfer
    module procedure integ1_end_vector_xfer
    module procedure integ1_matrix_end_xfer
    module procedure logicl_end_vector_xfer
    module procedure logicl_matrix_end_xfer
    module procedure single_end_vector_xfer
    module procedure single_matrix_end_xfer
    module procedure double_end_vector_xfer
    module procedure double_matrix_end_xfer
    module procedure cmpxr4_end_vector_xfer
    module procedure cmpxr4_matrix_end_xfer
    module procedure cmpxr8_end_vector_xfer
    module procedure cmpxr8_matrix_end_xfer
  end interface

  public :: lmpi_enda_xfer
  interface lmpi_enda_xfer
    module procedure integr_enda_vector_xfer
    module procedure integr_matrix_enda_xfer
    module procedure integ8_enda_vector_xfer
    module procedure integ8_matrix_enda_xfer
    module procedure integ1_enda_vector_xfer
    module procedure integ1_matrix_enda_xfer
    module procedure logicl_enda_vector_xfer
    module procedure logicl_matrix_enda_xfer
    module procedure single_enda_vector_xfer
    module procedure single_matrix_enda_xfer
    module procedure double_enda_vector_xfer
    module procedure double_matrix_enda_xfer
    module procedure cmpxr4_enda_vector_xfer
    module procedure cmpxr4_matrix_enda_xfer
    module procedure cmpxr8_enda_vector_xfer
    module procedure cmpxr8_matrix_enda_xfer
  end interface

  public :: lmpi_xferedge
  interface lmpi_xferedge
    module procedure integr_vector_xferedge
    module procedure integ8_vector_xferedge
    module procedure integ1_vector_xferedge
    module procedure logicl_vector_xferedge
    module procedure single_vector_xferedge
    module procedure double_vector_xferedge
    module procedure cmpxr4_vector_xferedge
    module procedure cmpxr8_vector_xferedge
  end interface

  public :: lmpi_xfer_jacobian
  interface lmpi_xfer_jacobian
    module procedure integr_xfer_jacobian
    module procedure integ8_xfer_jacobian
    module procedure integ1_xfer_jacobian
    module procedure logicl_xfer_jacobian
    module procedure single_xfer_jacobian
    module procedure double_xfer_jacobian
    module procedure cmpxr4_xfer_jacobian
    module procedure cmpxr8_xfer_jacobian
  end interface

  public :: lmpi_sumnode
  interface lmpi_sumnode
    module procedure integr_vector_sumnode
    module procedure integr_matrix_sumnode
    module procedure integ8_vector_sumnode
    module procedure integ8_matrix_sumnode
    module procedure integ1_vector_sumnode
    module procedure integ1_matrix_sumnode
    module procedure logicl_vector_sumnode
    module procedure logicl_matrix_sumnode
    module procedure single_vector_sumnode
    module procedure single_matrix_sumnode
    module procedure double_vector_sumnode
    module procedure double_matrix_sumnode
    module procedure cmpxr4_vector_sumnode
    module procedure cmpxr4_matrix_sumnode
    module procedure cmpxr8_vector_sumnode
    module procedure cmpxr8_matrix_sumnode
  end interface

  public :: lmpi_maxnode
  interface lmpi_maxnode
    module procedure integr_vector_maxnode
    module procedure integ8_vector_maxnode
    module procedure integ1_vector_maxnode
    module procedure logicl_vector_maxnode
    module procedure single_vector_maxnode
    module procedure double_vector_maxnode
    module procedure cmpxr4_vector_maxnode
    module procedure cmpxr8_vector_maxnode
  end interface

  public :: lmpi_sendreceive
  interface lmpi_sendreceive
    module procedure integr_vector_sendreceive
    module procedure integr_matrix_sendreceive
    module procedure integr_matrx3_sendreceive
    module procedure integr_matrx4_sendreceive
    module procedure integ8_vector_sendreceive
    module procedure integ8_matrix_sendreceive
    module procedure integ8_matrx3_sendreceive
    module procedure integ8_matrx4_sendreceive
    module procedure integ1_vector_sendreceive
    module procedure integ1_matrix_sendreceive
    module procedure integ1_matrx3_sendreceive
    module procedure integ1_matrx4_sendreceive
    module procedure logicl_vector_sendreceive
    module procedure logicl_matrix_sendreceive
    module procedure logicl_matrx3_sendreceive
    module procedure logicl_matrx4_sendreceive
    module procedure single_vector_sendreceive
    module procedure single_matrix_sendreceive
    module procedure single_matrx3_sendreceive
    module procedure single_matrx4_sendreceive
    module procedure double_vector_sendreceive
    module procedure double_matrix_sendreceive
    module procedure double_matrx3_sendreceive
    module procedure double_matrx4_sendreceive
    module procedure cmpxr4_vector_sendreceive
    module procedure cmpxr4_matrix_sendreceive
    module procedure cmpxr4_matrx3_sendreceive
    module procedure cmpxr4_matrx4_sendreceive
    module procedure cmpxr8_vector_sendreceive
    module procedure cmpxr8_matrix_sendreceive
    module procedure cmpxr8_matrx3_sendreceive
    module procedure cmpxr8_matrx4_sendreceive
  end interface

  public:: lmpi_copy


! ---------------------------------------- private only varables

  integer, parameter :: ndatalevel        = 4 ! number of mpi ghost levels
  integer            :: defaultghostlevel = 1 ! default mpi ghost level
  integer, parameter :: edgeghostlevel    = 3 ! mpi ghost level for edges

! integer :: gl = 1         ! Current grid level
! integer :: max_gl = 1     ! Max number of grid levels

  ! check_xfer variable to check array bounds for lmpi_xfer

#if HAVE_MPI
  logical :: check_xfer = .false., check_xfer01 = .false.
#endif
  integer :: xfer01

! sr1 has the send and recv data pairs for level-1 nodes

  type (basic_sendrecv_type), dimension(:), pointer :: sr1

  public :: sr1

! CUDA-enabled MPI

    public :: openacc_sendproc, openacc_recvproc
    public :: openacc_sendindex, openacc_recvindex
    public :: openacc_sendproc_offset, openacc_recvproc_offset
    public :: openacc_sendindex_offset, openacc_recvindex_offset
    public :: openacc_sendbuf, openacc_recvbuf
    public :: openacc_csendbuf, openacc_crecvbuf

    integer, dimension(:), pointer :: openacc_sendproc         => null()
    integer, dimension(:), pointer :: openacc_recvproc         => null()
    integer, dimension(:), pointer :: openacc_sendindex        => null()
    integer, dimension(:), pointer :: openacc_recvindex        => null()
    integer, dimension(:), pointer :: openacc_sendproc_offset  => null()
    integer, dimension(:), pointer :: openacc_recvproc_offset  => null()
    integer, dimension(:), pointer :: openacc_sendindex_offset => null()
    integer, dimension(:), pointer :: openacc_recvindex_offset => null()

    real(dqp), dimension(:,:), pointer :: openacc_sendbuf => null()
    real(dqp), dimension(:,:), pointer :: openacc_recvbuf => null()

    complex(dqp), dimension(:,:), pointer :: openacc_csendbuf => null()
    complex(dqp), dimension(:,:), pointer :: openacc_crecvbuf => null()

  contains

!================================== lmpi_set_defaultghostlevel ===============80
!
! Set defaultghostlevel
!
!=============================================================================80

  subroutine lmpi_set_defaultghostlevel(ghost_level_arg)

    integer,  intent(in) :: ghost_level_arg

    continue

    defaultghostlevel = ghost_level_arg

  end subroutine lmpi_set_defaultghostlevel

!=========================== LMPI_SET_CHECK_XFER01 ===========================80
!
! set check_xfer01 (to bypass checks for info stored only on fine grid).
!
!=============================================================================80

  subroutine lmpi_set_check_xfer01( argument )

    logical, intent(in) :: argument

  continue

#ifdef HAVE_MPI
    check_xfer01 = argument
#else
    print*,argument
#endif

  end subroutine lmpi_set_check_xfer01

!================================== LMPI_SET_XFER01 ==========================80
!
! set xfer01 information.
!
!=============================================================================80

  subroutine lmpi_set_xfer01( argument )

    integer, intent(in) :: argument

  continue

    xfer01 = argument
#ifdef HAVE_MPI
    check_xfer01 = .true.
#endif

  end subroutine lmpi_set_xfer01

!================================== CHECK_SIZE01 =============================80
!
! check size of xfer information
!
!=============================================================================80

  subroutine check_size01( argument, site )

    use lmpi, only : lmpi_conditional_stop

    integer,                intent(in) :: argument
    character(*), optional, intent(in) :: site

    integer :: ierr

  continue

    ierr = xfer01 - argument
    if ( ierr /= 0 ) then
       write(*,*) ' xfer size array=',argument,' expected size=',xfer01
      if ( present(site) ) write(*,*) ' site=',site
    endif
    call lmpi_conditional_stop(ierr,'multigrid xfer issue:check_size01')

  end subroutine check_size01


!========================== LMPI_SET_CHECK_XFER ==============================80
!
! sets the default check_xfer value used in lmpi_xfer routines
!
!=============================================================================80

  subroutine lmpi_set_check_xfer(check_xfer_value)

    logical, optional, intent(in) :: check_xfer_value

    continue

#ifdef HAVE_MPI
    if(present(check_xfer_value)) then
      check_xfer = check_xfer_value
    else
      check_xfer = .true.
    endif
#else
    if(present(check_xfer_value)) print*,check_xfer_value
#endif

  end subroutine lmpi_set_check_xfer


!================================== LMPI_WRITEME =============================80
!
! Writes the the sendproc, recvproc, sendindex, and recvindex arrays
!  to gridpart file (public)
!
!=============================================================================80

  subroutine lmpi_writeme(iunit, outformat)

    integer, intent(in) :: iunit
    logical, intent(in) :: outformat

    character(len=80) :: iformatdesc
    integer           :: idata

#ifdef HAVE_MPI
    integer :: i
    integer :: nparts
#endif

    continue

    iformatdesc = '(i10)'

#ifdef HAVE_MPI
    nparts = lmpi_nproc

    if (outformat) then
      write (iunit,iformatdesc) nparts,                                        &
        (sr(idata)%size_sendindex, sr(idata)%size_recvindex,                   &
        idata=1,ndatalevel)
    else
      write (iunit) nparts,                                                    &
        (sr(idata)%size_sendindex, sr(idata)%size_recvindex,                   &
        idata=1,ndatalevel)
    endif

    if (nparts > 1 ) then

      if (outformat) then

        do idata =1,ndatalevel

          write(iunit,iformatdesc)                                             &
            (sr(idata)%sendproc(i),i=1,nparts+1),                              &
            (sr(idata)%recvproc(i),i=1,nparts+1)
          write(iunit,iformatdesc)                                             &
            (sr(idata)%sendindex(i),i=1,sr(idata)%size_sendindex),             &
            (sr(idata)%recvindex(i),i=1,sr(idata)%size_recvindex)

        enddo

      else

        do idata =1,ndatalevel

          write(iunit)                                                         &
            (sr(idata)%sendproc(i),i=1,nparts+1),                              &
            (sr(idata)%recvproc(i),i=1,nparts+1)
          write(iunit)                                                         &
            (sr(idata)%sendindex(i),i=1,sr(idata)%size_sendindex),             &
            (sr(idata)%recvindex(i),i=1,sr(idata)%size_recvindex)

        enddo

      endif

    else

      if (outformat) then

        do idata = 1, ndatalevel

          write(iunit,iformatdesc) -999 ! one level of stuff
          write(iunit,iformatdesc) -999 ! one level of stuff

        enddo

      else

        do idata = 1, ndatalevel

          write(iunit) -999 ! one level of stuff
          write(iunit) -999 ! one level of stuff

        enddo

      endif

    endif

#else
    if (outformat) then
      write(iunit,iformatdesc) lmpi_nproc
      do idata = 1, ndatalevel
        write(iunit,iformatdesc) -999 ! one level of stuff
        write(iunit,iformatdesc) -999 ! one level of stuff
      end do
    else
      write(iunit) lmpi_nproc
      do idata = 1, ndatalevel
        write(iunit) -999 ! one level of stuff
        write(iunit) -999 ! one level of stuff
      end do
    end if
#endif

  end subroutine lmpi_writeme


!================================== LMPI_GETPROC_XFER ========================80
!
! Get send/recv proc.
!
!=============================================================================80

  subroutine lmpi_getproc_xfer(sendproc, recvproc )

    integer, dimension(lmpi_nproc+1), intent(out) :: sendproc,  recvproc

    integer :: lvl

    continue

    lvl = defaultghostlevel

    if (sr_allocated) then
      sendproc  = sr(lvl)%sendproc
      recvproc  = sr(lvl)%recvproc
    else
      sendproc  = -999
      recvproc  = -999
    end if

  end subroutine lmpi_getproc_xfer

!================================== LMPI_GETINDEX_XFER =======================80
!
! Get send/recv index.
!
!=============================================================================80

  subroutine lmpi_getindex_xfer(senddim, recvdim, sendindex, recvindex )

    integer, intent(in) :: senddim, recvdim
    integer, dimension(senddim), intent(out) :: sendindex
    integer, dimension(recvdim), intent(out) :: recvindex

    integer :: lvl

    continue

    lvl = defaultghostlevel

    if (sr_allocated) then
      sendindex(1:senddim) = sr(lvl)%sendindex(1:senddim)
      recvindex(1:recvdim) = sr(lvl)%recvindex(1:recvdim)
    else
      sendindex(1:senddim)  = -999
      recvindex(1:recvdim)  = -999
    end if

  end subroutine lmpi_getindex_xfer


!================================== LMPI_TEST_XFER ===========================80
!
! test the lmpi_xfer routines
!
!=============================================================================80

  subroutine lmpi_test_xfer( lastlocalnode, lastghostnode, l2g )

#ifdef HAVE_MPI
    use lmpi,        only : lmpi_conditional_stop
#endif
    use kinddefs,    only : i8

    integer,               intent(in) :: lastlocalnode, lastghostnode
    integer(i8), dimension(:), intent(in) :: l2g

#ifdef HAVE_MPI
    integer :: node, istop
    integer(i8), dimension(lastghostnode) :: globalnodeindex
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! for mpi with one proc

    globalnodeindex = -1
    do node = 1, lastlocalnode
      globalnodeindex(node) = l2g(node)
    end do
    call lmpi_xfer(globalnodeindex)
    istop = 0
    do node = 1, lastlocalnode
      if (globalnodeindex(node) /= l2g(node)) then
        write(*,'(a,i4,a,i10,a,2i10)') ' proc ', lmpi_id, ' local node ',node, &
          ' overwritten ', globalnodeindex(node), l2g(node)
        istop = 1
      end if
    end do
    do node = lastlocalnode+1, lastghostnode
      if (globalnodeindex(node) /= l2g(node)) then
        write(*,'(a,i4,a,i10,a,2i10)') ' proc ', lmpi_id, ' ghost node ',node, &
          ' incorrect ', globalnodeindex(node), l2g(node)
        istop = 1
      end if
    end do
    call lmpi_conditional_stop(istop)
#else
! avoid compiler warnings
    if (.false.) write(*,*) lastlocalnode,lastghostnode, l2g
#endif

  end subroutine lmpi_test_xfer

!============================ LMPI_RESET_SENDRECV ============================80
!
! reset the values of the sr send recieve pairs used by lmpi_xfer
!
!=============================================================================80

  subroutine lmpi_reset_sendrecv( lvl, sendproc, sendindex, recvproc, recvindex)

#ifdef HAVE_MPI
    use lmpi,        only : lmpi_conditional_stop
#endif

    integer,               intent(in) :: lvl
    integer, dimension(:), intent(in) :: sendproc, sendindex
    integer, dimension(:), intent(in) :: recvproc, recvindex

#ifdef HAVE_MPI
    integer :: index
    integer :: istop
    integer :: senddim, recvdim
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! for mpi with one proc

    call lmpi_deallocate_sendrecv(lvl)

    istop = 0
    if ( size(sendproc,1) /= lmpi_nproc+1 .or.                                 &
         size(recvproc,1) /= lmpi_nproc+1 ) then
      istop = 1
      write(*,*) lmpi_id, "lmpi_reset_sendrecv: sendproc, recvproc size",      &
        lmpi_nproc+1, size(sendproc,1), size(recvproc,1)
    end if
    call lmpi_conditional_stop(istop)

    senddim = sendproc(lmpi_nproc+1) - 1
    recvdim = recvproc(lmpi_nproc+1) - 1

    istop = 0
    if (size(sendindex,1) /= senddim .or. size(recvindex,1) /= recvdim ) then
      istop = 1
      write(*,*) lmpi_id, "lmpi_reset_sendrecv: sendindex, recvindex size",    &
        size(sendindex,1), senddim, size(recvindex,1), recvdim
    end if
    call lmpi_conditional_stop(istop)

    sr(lvl)%sendrecv_allocated = .true.
    allocate(sr(lvl)%sendproc(lmpi_nproc+1))
    allocate(sr(lvl)%recvproc(lmpi_nproc+1))
    do index = 1, lmpi_nproc + 1
      sr(lvl)%sendproc(index) = sendproc(index)
      sr(lvl)%recvproc(index) = recvproc(index)
    end do

    sr(lvl)%size_sendindex = senddim
    allocate(sr(lvl)%sendindex(max(1,senddim)))
    do index = 1, senddim
      sr(lvl)%sendindex(index) = sendindex(index)
    end do

    sr(lvl)%size_recvindex = recvdim
    allocate(sr(lvl)%recvindex(max(1,recvdim)))
    do index = 1, recvdim
      sr(lvl)%recvindex(index) = recvindex(index)
    end do

#else
! avoid compiler warnings
    if (.false.) write(*,*) lvl, sendindex, sendproc, recvindex, recvproc
#endif

  end subroutine lmpi_reset_sendrecv


!====================== DOUBLE_COLLECT_RES ===================================80
!
! Collects local residual contribution to global residual from each processor
! (public)
!
! Note, the mpi_maxloc2 within mpi_reduce takes two values (denoted here as
! val1 and val2).  mpi_maxloc2 finds the largest val1 amoung all processors,
! then returns the smallest val2.  If two or more processors match max(val1),
! then val2 is the smallest.  The intent of this routine is to keep all
! xloc,yloc,zloc tuples together as an entity.  The previous version of this
! routine would allow elements of the tuple to be gathered from different
! processors.  I.e., if rmax matched two or more PEs, then the smallest
! xloc,yloc,zloc amoung those PEs would be returned; where each loc value
! would be determined independently.
!
! The current approach finds the max(val1) and the associated min(pid).
! Then the loc values are obtained from the single source (min(pid)).
!
!=============================================================================80

  subroutine double_collect_res(rms, cputime, rmax, xloc, yloc, zloc)

    real(dp),                    intent(inout) :: rms, cputime
    real(dp),                    intent(inout) :: rmax,xloc,yloc,zloc

    real(dp), dimension (2)                    :: r,s
    real(dp), dimension (2,1)                  :: in, out

    integer                             :: id_of_max_rmax
#ifdef HAVE_MPI
    integer                              :: ierr
    real(dp), dimension (3)              :: out_loc
#endif

    continue

    r(01) = rms
    r(02) = cputime

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    rms     = s(01)
    cputime = s(02)

!   find max global residual location

    in(1,1) = rmax
    in(2,1) = real(lmpi_id,dp)

    call lmpi_reduce_maxloc2( in, out )
    if (lmpi_master) then
       rmax = out(1,1)
       id_of_max_rmax = int(out(2,1))
    end if

#ifdef HAVE_MPI
    call lmpi_bcast(id_of_max_rmax)

    if (id_of_max_rmax /= 0) then
       if (lmpi_id == 0) then
          !write(*,*)lmpi_id,': recv from ',id_of_max_rmax
          call lmpi_recv(out_loc,3,id_of_max_rmax,1,ierr)
          xloc = out_loc(1)
          yloc = out_loc(2)
          zloc = out_loc(3)
       else if (lmpi_id == id_of_max_rmax) then
          !write(*,*)lmpi_id,': send to  ',0
          out_loc(1) = xloc
          out_loc(2) = yloc
          out_loc(3) = zloc
          call lmpi_send(out_loc,3,0,1,ierr)
       end if
    end if
#else
! avoid compiler warnings
    if (.false.) write(*,*) rmax, xloc, yloc, zloc, id_of_max_rmax
#endif

  end subroutine double_collect_res


!====================== DOUBLE_COMPLEX_COLLECT_RES ===========================80
!
! Collects local residual contribution to global residual from each processor
! (public)
!
! This complex version only reduces the real parts!!!
!
!=============================================================================80

  subroutine double_complex_collect_res(rms, cputime, rmax, xloc, yloc, zloc)

    complex(dp),                    intent(inout) :: rms, cputime
    complex(dp),                    intent(inout) :: rmax,xloc,yloc,zloc

    real(dp), dimension (2)                    :: r,s
    real(dp), dimension (2,1)                  :: in, out

    integer :: id_of_max_rmax

#ifdef HAVE_MPI
    integer, dimension(lmpi_status_size) :: status
    integer                              :: ierr
#endif

    continue

    r(01) = real(rms,dp)
    r(02) = real(cputime,dp)

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    rms     = cmplx(s(01), aimag(rms), dp)
    cputime = cmplx(s(02), aimag(cputime), dp)

!   find max global residual location

    in(1,1) = real(rmax,    dp)
    in(2,1) = real(lmpi_id, dp)

    call lmpi_reduce_maxloc2( in, out )
    if (lmpi_master) then
       rmax = cmplx(out(1,1), aimag(rmax), dp)
       id_of_max_rmax = int(out(2,1))
    end if

#ifdef HAVE_MPI
    call lmpi_bcast(id_of_max_rmax)

    if (id_of_max_rmax /= 0) then
       if (lmpi_id == 0) then
         !write(*,*)lmpi_id,': recv from ',id_of_max_rmax
         !write(*,*)'recv(2)'
         call mpi_recv(xloc,1,mpi_double_complex,id_of_max_rmax,               &
                      1,lmpi_comm,status,ierr)
         call mpi_recv(yloc,1,mpi_double_complex,id_of_max_rmax,               &
                      1,lmpi_comm,status,ierr)
         call mpi_recv(zloc,1,mpi_double_complex,id_of_max_rmax,               &
                      1,lmpi_comm,status,ierr)
       else if (lmpi_id == id_of_max_rmax) then
         !write(*,*)lmpi_id,': send to  ',0
         !write(*,*)'send(2)'
         call mpi_send(xloc,1,mpi_double_complex,0,1,lmpi_comm,ierr)
         call mpi_send(yloc,1,mpi_double_complex,0,1,lmpi_comm,ierr)
         call mpi_send(zloc,1,mpi_double_complex,0,1,lmpi_comm,ierr)
       end if
    end if
#else
! avoid compiler warnings
    if (.false.) write(*,*) rmax, xloc, yloc, zloc, id_of_max_rmax
#endif

  end subroutine double_complex_collect_res


!============================ LMPI_START_CUDAMPI_XFER_R4 =====================80
!
! Initiate non-blocking send/receive pair for rank 2 single data using
! CUDA-enabled MPI
!
!=============================================================================80
  subroutine lmpi_start_cudampi_xfer_r4(color,data,sr_loc)

    integer, intent(in) :: color

    real(system_r4), dimension(:,:), intent(in) :: data

    type(sendrecv_type), intent(in) :: sr_loc

#ifdef HAVE_MPI
    integer :: ierr, mpitag, length, nleaddim, inde, inode, l, i_other_proc
    integer :: sendproc_offset, sendind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Post the receives

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle recv_loop

      length = sr_loc%recvproc(i_other_proc+2) - sr_loc%recvproc(i_other_proc+1)

      if ( length > 0 ) then

        nrecv  = nrecv + 1
        mpitag = 2

!$acc data present(openacc_recvbuf)
!$acc host_data use_device(openacc_recvbuf)
        call mpi_irecv(openacc_recvbuf(1,sr_loc%recvproc(i_other_proc+1)),     &
                       length*nleaddim,mpi_real,i_other_proc,mpitag,lmpi_comm, &
                       recvreq(nrecv),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_irecv (lmpi_start_cudampi_xfer) failed... '
        endif

      endif

    enddo recv_loop

! Fill the send buffer on the device

    sendproc_offset = openacc_sendproc_offset(color)
    sendind_offset  = openacc_sendindex_offset(color)

!$acc parallel present(openacc_sendproc,openacc_sendindex,data,                &
!$acc                  openacc_sendbuf)
!$acc loop
    do inde = 1, openacc_sendproc(lmpi_nproc+1+sendproc_offset)-1
      inode = openacc_sendindex(inde+sendind_offset)
      do l = 1, nleaddim
        openacc_sendbuf(l,inde) = data(l,inode)
      enddo
    end do
!$acc end parallel

! Post the sends

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle send_loop

      length = sr_loc%sendproc(i_other_proc+2) - sr_loc%sendproc(i_other_proc+1)

      if ( length > 0 ) then

        nsend  = nsend + 1
        mpitag = 2

!$acc data present(openacc_sendbuf)
!$acc host_data use_device(openacc_sendbuf)
        call mpi_isend(openacc_sendbuf(1,sr_loc%sendproc(i_other_proc+1)),     &
                       length*nleaddim,mpi_real,i_other_proc,mpitag,lmpi_comm, &
                       sendreq(nsend),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_isend (lmpi_start_cudampi_xfer) failed...'
        endif

      endif

    enddo send_loop

#else
    if (.false.) write(*,*) color, data, sr_loc%size_sendindex
#endif

  end subroutine lmpi_start_cudampi_xfer_r4


!============================ LMPI_START_CUDAMPI_XFER_R8 =====================80
!
! Initiate non-blocking send/receive pair for rank 2 double data using
! CUDA-enabled MPI
!
!=============================================================================80
  subroutine lmpi_start_cudampi_xfer_r8(color,data,sr_loc)

    integer, intent(in) :: color

    real(system_r8), dimension(:,:), intent(in) :: data

    type(sendrecv_type), intent(in) :: sr_loc

#ifdef HAVE_MPI
    integer :: ierr, mpitag, length, nleaddim, inde, inode, l, i_other_proc
    integer :: sendproc_offset, sendind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Post the receives

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle recv_loop

      length = sr_loc%recvproc(i_other_proc+2) - sr_loc%recvproc(i_other_proc+1)

      if ( length > 0 ) then

        nrecv  = nrecv + 1
        mpitag = 2

!$acc data present(openacc_recvbuf)
!$acc host_data use_device(openacc_recvbuf)
        call mpi_irecv(openacc_recvbuf(1,sr_loc%recvproc(i_other_proc+1)),     &
                       length*nleaddim,mpi_double_precision,i_other_proc,      &
                       mpitag,lmpi_comm,recvreq(nrecv),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_irecv (lmpi_start_cudampi_xfer) failed... '
        endif

      endif

    enddo recv_loop

! Fill the send buffer on the device

    sendproc_offset = openacc_sendproc_offset(color)
    sendind_offset  = openacc_sendindex_offset(color)

!$acc parallel present(openacc_sendproc,openacc_sendindex,data,                &
!$acc                  openacc_sendbuf)
!$acc loop
    do inde = 1, openacc_sendproc(lmpi_nproc+1+sendproc_offset)-1
      inode = openacc_sendindex(inde+sendind_offset)
      do l = 1, nleaddim
        openacc_sendbuf(l,inde) = data(l,inode)
      enddo
    end do
!$acc end parallel

! Post the sends

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle send_loop

      length = sr_loc%sendproc(i_other_proc+2) - sr_loc%sendproc(i_other_proc+1)

      if ( length > 0 ) then

        nsend  = nsend + 1
        mpitag = 2

!$acc data present(openacc_sendbuf)
!$acc host_data use_device(openacc_sendbuf)
        call mpi_isend(openacc_sendbuf(1,sr_loc%sendproc(i_other_proc+1)),     &
                       length*nleaddim,mpi_double_precision,i_other_proc,      &
                       mpitag,lmpi_comm,sendreq(nsend),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_isend (lmpi_start_cudampi_xfer) failed...'
        endif

      endif

    enddo send_loop

#else
    if (.false.) write(*,*) color, data, sr_loc%size_sendindex
#endif

  end subroutine lmpi_start_cudampi_xfer_r8


!============================ LMPI_START_CUDAMPI_XFER_C4 =====================80
!
! Initiate non-blocking send/receive pair for rank 2 single data using
! CUDA-enabled MPI - complex
!
!=============================================================================80
  subroutine lmpi_start_cudampi_xfer_c4(color,data,sr_loc)

    integer, intent(in) :: color

    complex(system_r4), dimension(:,:), intent(in) :: data

    type(sendrecv_type), intent(in) :: sr_loc

#ifdef HAVE_MPI
    integer :: ierr, mpitag, length, nleaddim, inde, inode, l, i_other_proc
    integer :: sendproc_offset, sendind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Post the receives

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle recv_loop

      length = sr_loc%recvproc(i_other_proc+2) - sr_loc%recvproc(i_other_proc+1)

      if ( length > 0 ) then

        nrecv  = nrecv + 1
        mpitag = 2

!$acc data present(openacc_crecvbuf)
!$acc host_data use_device(openacc_crecvbuf)
        call mpi_irecv(openacc_crecvbuf(1,sr_loc%recvproc(i_other_proc+1)),    &
                     length*nleaddim,mpi_complex,i_other_proc,mpitag,lmpi_comm,&
                     recvreq(nrecv),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_irecv (lmpi_start_cudampi_xfer) failed... '
        endif

      endif

    enddo recv_loop

! Fill the send buffer on the device

    sendproc_offset = openacc_sendproc_offset(color)
    sendind_offset  = openacc_sendindex_offset(color)

!$acc parallel present(openacc_sendproc,openacc_sendindex,data,                &
!$acc                  openacc_csendbuf)
!$acc loop
    do inde = 1, openacc_sendproc(lmpi_nproc+1+sendproc_offset)-1
      inode = openacc_sendindex(inde+sendind_offset)
      do l = 1, nleaddim
        openacc_csendbuf(l,inde) = data(l,inode)
      enddo
    end do
!$acc end parallel

! Post the sends

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle send_loop

      length = sr_loc%sendproc(i_other_proc+2) - sr_loc%sendproc(i_other_proc+1)

      if ( length > 0 ) then

        nsend  = nsend + 1
        mpitag = 2

!$acc data present(openacc_csendbuf)
!$acc host_data use_device(openacc_csendbuf)
        call mpi_isend(openacc_csendbuf(1,sr_loc%sendproc(i_other_proc+1)),    &
                     length*nleaddim,mpi_complex,i_other_proc,mpitag,lmpi_comm,&
                     sendreq(nsend),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_isend (lmpi_start_cudampi_xfer) failed...'
        endif

      endif

    enddo send_loop

#else
    if (.false.) write(*,*) color, data, sr_loc%size_sendindex
#endif

  end subroutine lmpi_start_cudampi_xfer_c4


!============================ LMPI_START_CUDAMPI_XFER_C8 =====================80
!
! Initiate non-blocking send/receive pair for rank 2 double data using
! CUDA-enabled MPI - complex
!
!=============================================================================80
  subroutine lmpi_start_cudampi_xfer_c8(color,data,sr_loc)

    integer, intent(in) :: color

    complex(system_r8), dimension(:,:), intent(in) :: data

    type(sendrecv_type), intent(in) :: sr_loc

#ifdef HAVE_MPI
    integer :: ierr, mpitag, length, nleaddim, inde, inode, l, i_other_proc
    integer :: sendproc_offset, sendind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Post the receives

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle recv_loop

      length = sr_loc%recvproc(i_other_proc+2) - sr_loc%recvproc(i_other_proc+1)

      if ( length > 0 ) then

        nrecv  = nrecv + 1
        mpitag = 2

!$acc data present(openacc_crecvbuf)
!$acc host_data use_device(openacc_crecvbuf)
        call mpi_irecv(openacc_crecvbuf(1,sr_loc%recvproc(i_other_proc+1)),    &
                       length*nleaddim,mpi_double_complex,i_other_proc,        &
                       mpitag,lmpi_comm,recvreq(nrecv),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_irecv (lmpi_start_cudampi_xfer) failed... '
        endif

      endif

    enddo recv_loop

! Fill the send buffer on the device

    sendproc_offset = openacc_sendproc_offset(color)
    sendind_offset  = openacc_sendindex_offset(color)

!$acc parallel present(openacc_sendproc,openacc_sendindex,data,                &
!$acc                  openacc_csendbuf)
!$acc loop
    do inde = 1, openacc_sendproc(lmpi_nproc+1+sendproc_offset)-1
      inode = openacc_sendindex(inde+sendind_offset)
      do l = 1, nleaddim
        openacc_csendbuf(l,inde) = data(l,inode)
      enddo
    end do
!$acc end parallel

! Post the sends

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if ( i_other_proc == lmpi_id ) cycle send_loop

      length = sr_loc%sendproc(i_other_proc+2) - sr_loc%sendproc(i_other_proc+1)

      if ( length > 0 ) then

        nsend  = nsend + 1
        mpitag = 2

!$acc data present(openacc_csendbuf)
!$acc host_data use_device(openacc_csendbuf)
        call mpi_isend(openacc_csendbuf(1,sr_loc%sendproc(i_other_proc+1)),    &
                       length*nleaddim,mpi_double_complex,i_other_proc,        &
                       mpitag,lmpi_comm,sendreq(nsend),ierr)
!$acc end host_data
!$acc end data

        if ( ierr /= lmpi_success ) then
          print *, 'mpi_isend (lmpi_start_cudampi_xfer) failed...'
        endif

      endif

    enddo send_loop

#else
    if (.false.) write(*,*) color, data, sr_loc%size_sendindex
#endif

  end subroutine lmpi_start_cudampi_xfer_c8


!========================= LMPI_COMPLETE_CUDAMPI_XFER_R4 =====================80
!
! Finalize non-blocking send/receive pair for rank 2 single data using
! CUDA-enabled MPI
!
!=============================================================================80
  subroutine lmpi_complete_cudampi_xfer_r4(color,data)

    integer, intent(in) :: color

    real(system_r4), dimension(:,:), intent(inout) :: data

#ifdef HAVE_MPI
    integer :: ierr, inde, inode, l, nleaddim, recvproc_offset, recvind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Wait for all mpi communication to complete

    ierr = lmpi_success
    if ( nsend > 0 ) call lmpi_waitall(nsend, sendreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'send mpi_wait in complete_cudampi_xfer failed...'
    endif

    ierr = lmpi_success
    if ( nrecv > 0 ) call lmpi_waitall(nrecv, recvreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'recv mpi_wait in complete_cudampi_xfer failed...'
    endif

! Empty the recv buffer on the device

    recvproc_offset = openacc_recvproc_offset(color)
    recvind_offset  = openacc_recvindex_offset(color)

!$acc parallel present(openacc_recvproc,openacc_recvindex,data,                &
!$acc                  openacc_recvbuf)
!$acc loop
    do inde = 1, openacc_recvproc(lmpi_nproc+1+recvproc_offset) - 1
      inode = openacc_recvindex(inde+recvind_offset)
      do l = 1, nleaddim
        data(l,inode) = openacc_recvbuf(l,inde)
      enddo
    enddo
!$acc end parallel

#else
    if (.false.) write(*,*) color, data
#endif

  end subroutine lmpi_complete_cudampi_xfer_r4


!========================= LMPI_COMPLETE_CUDAMPI_XFER_R8 =====================80
!
! Finalize non-blocking send/receive pair for rank 2 double data using
! CUDA-enabled MPI
!
!=============================================================================80
  subroutine lmpi_complete_cudampi_xfer_r8(color,data)

    integer, intent(in) :: color

    real(system_r8), dimension(:,:), intent(inout) :: data

#ifdef HAVE_MPI
    integer :: ierr, inde, inode, l, nleaddim, recvproc_offset, recvind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Wait for all mpi communication to complete

    ierr = lmpi_success
    if ( nsend > 0 ) call lmpi_waitall(nsend, sendreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'send mpi_wait in complete_cudampi_xfer failed...'
    endif

    ierr = lmpi_success
    if ( nrecv > 0 ) call lmpi_waitall(nrecv, recvreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'recv mpi_wait in complete_cudampi_xfer failed...'
    endif

! Empty the recv buffer on the device

    recvproc_offset = openacc_recvproc_offset(color)
    recvind_offset  = openacc_recvindex_offset(color)

!$acc parallel present(openacc_recvproc,openacc_recvindex,data,                &
!$acc                  openacc_recvbuf)
!$acc loop
    do inde = 1, openacc_recvproc(lmpi_nproc+1+recvproc_offset) - 1
      inode = openacc_recvindex(inde+recvind_offset)
      do l = 1, nleaddim
        data(l,inode) = openacc_recvbuf(l,inde)
      enddo
    enddo
!$acc end parallel

#else
    if (.false.) write(*,*) color, data
#endif

  end subroutine lmpi_complete_cudampi_xfer_r8


!========================= LMPI_COMPLETE_CUDAMPI_XFER_C4 =====================80
!
! Finalize non-blocking send/receive pair for rank 2 single data using
! CUDA-enabled MPI - complex
!
!=============================================================================80
  subroutine lmpi_complete_cudampi_xfer_c4(color,data)

    integer, intent(in) :: color

    complex(system_r4), dimension(:,:), intent(inout) :: data

#ifdef HAVE_MPI
    integer :: ierr, inde, inode, l, nleaddim, recvproc_offset, recvind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Wait for all mpi communication to complete

    ierr = lmpi_success
    if ( nsend > 0 ) call lmpi_waitall(nsend, sendreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'send mpi_wait in complete_cudampi_xfer failed...'
    endif

    ierr = lmpi_success
    if ( nrecv > 0 ) call lmpi_waitall(nrecv, recvreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'recv mpi_wait in complete_cudampi_xfer failed...'
    endif

! Empty the recv buffer on the device

    recvproc_offset = openacc_recvproc_offset(color)
    recvind_offset  = openacc_recvindex_offset(color)

!$acc parallel present(openacc_recvproc,openacc_recvindex,data,                &
!$acc                  openacc_crecvbuf)
!$acc loop
    do inde = 1, openacc_recvproc(lmpi_nproc+1+recvproc_offset) - 1
      inode = openacc_recvindex(inde+recvind_offset)
      do l = 1, nleaddim
        data(l,inode) = openacc_crecvbuf(l,inde)
      enddo
    enddo
!$acc end parallel

#else
    if (.false.) write(*,*) color, data
#endif

  end subroutine lmpi_complete_cudampi_xfer_c4


!========================= LMPI_COMPLETE_CUDAMPI_XFER_C8 =====================80
!
! Finalize non-blocking send/receive pair for rank 2 double data using
! CUDA-enabled MPI - complex
!
!=============================================================================80
  subroutine lmpi_complete_cudampi_xfer_c8(color,data)

    integer, intent(in) :: color

    complex(system_r8), dimension(:,:), intent(inout) :: data

#ifdef HAVE_MPI
    integer :: ierr, inde, inode, l, nleaddim, recvproc_offset, recvind_offset
#endif

  continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return

    nleaddim = size(data,1)

! Wait for all mpi communication to complete

    ierr = lmpi_success
    if ( nsend > 0 ) call lmpi_waitall(nsend, sendreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'send mpi_wait in complete_cudampi_xfer failed...'
    endif

    ierr = lmpi_success
    if ( nrecv > 0 ) call lmpi_waitall(nrecv, recvreq, ierr)

    if ( ierr /= lmpi_success ) then
      print *, 'recv mpi_wait in complete_cudampi_xfer failed...'
    endif

! Empty the recv buffer on the device

    recvproc_offset = openacc_recvproc_offset(color)
    recvind_offset  = openacc_recvindex_offset(color)

!$acc parallel present(openacc_recvproc,openacc_recvindex,data,                &
!$acc                  openacc_crecvbuf)
!$acc loop
    do inde = 1, openacc_recvproc(lmpi_nproc+1+recvproc_offset) - 1
      inode = openacc_recvindex(inde+recvind_offset)
      do l = 1, nleaddim
        data(l,inode) = openacc_crecvbuf(l,inde)
      enddo
    enddo
!$acc end parallel

#else
    if (.false.) write(*,*) color, data
#endif

  end subroutine lmpi_complete_cudampi_xfer_c8

!tempStartExpand(lmpi_collect_forces)
!============================= integr_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine integr_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    integer(system_i4), intent(inout) :: clp,cdp,clv,cdv
    integer(system_i4), intent(inout) :: cmxp,cmyp,cmzp
    integer(system_i4), intent(inout) :: cmxv,cmyv,cmzv
    integer(system_i4), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    integer(system_i4), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    integer(system_i4), intent(inout) :: powerx,powery,powerz
    integer(system_i4), intent(inout), optional :: mass, momx, momy, momz
    integer(system_i4), intent(inout), optional :: delpx, delpy, delpz
    integer(system_i4), intent(inout), optional :: press
    integer(system_i4), intent(inout), optional :: pt, pt_min, pt_max
    integer(system_i4), intent(inout), optional :: rho, area
    integer(system_i4), intent(inout), optional :: tt, temp, tt_rms

    integer(system_i4), dimension (44) :: r,s

    continue

    r = 0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine integr_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= integ8_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine integ8_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    integer(system_i8), intent(inout) :: clp,cdp,clv,cdv
    integer(system_i8), intent(inout) :: cmxp,cmyp,cmzp
    integer(system_i8), intent(inout) :: cmxv,cmyv,cmzv
    integer(system_i8), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    integer(system_i8), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    integer(system_i8), intent(inout) :: powerx,powery,powerz
    integer(system_i8), intent(inout), optional :: mass, momx, momy, momz
    integer(system_i8), intent(inout), optional :: delpx, delpy, delpz
    integer(system_i8), intent(inout), optional :: press
    integer(system_i8), intent(inout), optional :: pt, pt_min, pt_max
    integer(system_i8), intent(inout), optional :: rho, area
    integer(system_i8), intent(inout), optional :: tt, temp, tt_rms

    integer(system_i8), dimension (44) :: r,s

    continue

    r = 0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine integ8_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= integ1_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine integ1_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    integer(system_i1), intent(inout) :: clp,cdp,clv,cdv
    integer(system_i1), intent(inout) :: cmxp,cmyp,cmzp
    integer(system_i1), intent(inout) :: cmxv,cmyv,cmzv
    integer(system_i1), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    integer(system_i1), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    integer(system_i1), intent(inout) :: powerx,powery,powerz
    integer(system_i1), intent(inout), optional :: mass, momx, momy, momz
    integer(system_i1), intent(inout), optional :: delpx, delpy, delpz
    integer(system_i1), intent(inout), optional :: press
    integer(system_i1), intent(inout), optional :: pt, pt_min, pt_max
    integer(system_i1), intent(inout), optional :: rho, area
    integer(system_i1), intent(inout), optional :: tt, temp, tt_rms

    integer(system_i1), dimension (44) :: r,s

    continue

    r = 0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine integ1_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= logicl_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine logicl_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    logical, intent(inout) :: clp,cdp,clv,cdv
    logical, intent(inout) :: cmxp,cmyp,cmzp
    logical, intent(inout) :: cmxv,cmyv,cmzv
    logical, intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    logical, intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    logical, intent(inout) :: powerx,powery,powerz
    logical, intent(inout), optional :: mass, momx, momy, momz
    logical, intent(inout), optional :: delpx, delpy, delpz
    logical, intent(inout), optional :: press
    logical, intent(inout), optional :: pt, pt_min, pt_max
    logical, intent(inout), optional :: rho, area
    logical, intent(inout), optional :: tt, temp, tt_rms

    logical, dimension (44) :: r,s

    continue

    r = .false.

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine logicl_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= single_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine single_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    real(system_r4), intent(inout) :: clp,cdp,clv,cdv
    real(system_r4), intent(inout) :: cmxp,cmyp,cmzp
    real(system_r4), intent(inout) :: cmxv,cmyv,cmzv
    real(system_r4), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    real(system_r4), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    real(system_r4), intent(inout) :: powerx,powery,powerz
    real(system_r4), intent(inout), optional :: mass, momx, momy, momz
    real(system_r4), intent(inout), optional :: delpx, delpy, delpz
    real(system_r4), intent(inout), optional :: press
    real(system_r4), intent(inout), optional :: pt, pt_min, pt_max
    real(system_r4), intent(inout), optional :: rho, area
    real(system_r4), intent(inout), optional :: tt, temp, tt_rms

    real(system_r4), dimension (44) :: r,s

    continue

    r = 0.0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine single_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= double_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine double_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    real(system_r8), intent(inout) :: clp,cdp,clv,cdv
    real(system_r8), intent(inout) :: cmxp,cmyp,cmzp
    real(system_r8), intent(inout) :: cmxv,cmyv,cmzv
    real(system_r8), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    real(system_r8), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    real(system_r8), intent(inout) :: powerx,powery,powerz
    real(system_r8), intent(inout), optional :: mass, momx, momy, momz
    real(system_r8), intent(inout), optional :: delpx, delpy, delpz
    real(system_r8), intent(inout), optional :: press
    real(system_r8), intent(inout), optional :: pt, pt_min, pt_max
    real(system_r8), intent(inout), optional :: rho, area
    real(system_r8), intent(inout), optional :: tt, temp, tt_rms

    real(system_r8), dimension (44) :: r,s

    continue

    r = 0.0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine double_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= cmpxr4_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine cmpxr4_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    complex(system_r4), intent(inout) :: clp,cdp,clv,cdv
    complex(system_r4), intent(inout) :: cmxp,cmyp,cmzp
    complex(system_r4), intent(inout) :: cmxv,cmyv,cmzv
    complex(system_r4), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    complex(system_r4), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    complex(system_r4), intent(inout) :: powerx,powery,powerz
    complex(system_r4), intent(inout), optional :: mass, momx, momy, momz
    complex(system_r4), intent(inout), optional :: delpx, delpy, delpz
    complex(system_r4), intent(inout), optional :: press
    complex(system_r4), intent(inout), optional :: pt, pt_min, pt_max
    complex(system_r4), intent(inout), optional :: rho, area
    complex(system_r4), intent(inout), optional :: tt, temp, tt_rms

    complex(system_r4), dimension (44) :: r,s

    continue

    r = 0.0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine cmpxr4_collect_forces
!tempStartExpand(lmpi_collect_forces)
!============================= cmpxr8_COLLECT_FORCES
!
! Collects local force contributions to global forces from each processor
! (public)
!
!=============================================================================80
  subroutine cmpxr8_collect_forces(clp,cdp,clv,cdv,cmxp,cmyp,cmzp,cmxv,cmyv,   &
                                 cmzv,cxp,cyp,czp,cxv,cyv,czv,cl,cd,cmx,       &
                                 cmy,cmz,cx,cy,cz,heat,powerx,powery,powerz,   &
                                 mass,momx,momy,momz,delpx,delpy,delpz,        &
                                 press,pt,pt_min,pt_max,                       &
                                 tt,temp,tt_rms,rho,area)

    complex(system_r8), intent(inout) :: clp,cdp,clv,cdv
    complex(system_r8), intent(inout) :: cmxp,cmyp,cmzp
    complex(system_r8), intent(inout) :: cmxv,cmyv,cmzv
    complex(system_r8), intent(inout) :: cxp,cyp,czp,cxv,cyv,czv
    complex(system_r8), intent(inout) :: cl,cd,cmx,cmy,cmz,cx,cy,cz,heat
    complex(system_r8), intent(inout) :: powerx,powery,powerz
    complex(system_r8), intent(inout), optional :: mass, momx, momy, momz
    complex(system_r8), intent(inout), optional :: delpx, delpy, delpz
    complex(system_r8), intent(inout), optional :: press
    complex(system_r8), intent(inout), optional :: pt, pt_min, pt_max
    complex(system_r8), intent(inout), optional :: rho, area
    complex(system_r8), intent(inout), optional :: tt, temp, tt_rms

    complex(system_r8), dimension (44) :: r,s

    continue

    r = 0.0

    r(01) = clp
    r(02) = cdp
    r(03) = clv
    r(04) = cdv

    r(05) = cmxp
    r(06) = cmyp
    r(07) = cmzp
    r(08) = cmxv
    r(09) = cmyv
    r(10) = cmzv

    r(11) = cxp
    r(12) = cyp
    r(13) = czp
    r(14) = cxv
    r(15) = cyv
    r(16) = czv

    r(17) = cl
    r(18) = cd
    r(19) = cmx
    r(20) = cmy
    r(21) = cmz
    r(22) = cx
    r(23) = cy
    r(24) = cz
    r(25) = heat
    r(26) = powerx
    r(27) = powery
    r(28) = powerz

    if ( present(mass)   ) r(29) = mass
    if ( present(momx)   ) r(30) = momx
    if ( present(momy)   ) r(31) = momy
    if ( present(momz)   ) r(32) = momz
    if ( present(delpx)  ) r(33) = delpx
    if ( present(delpy)  ) r(34) = delpy
    if ( present(delpz)  ) r(35) = delpz
    if ( present(press)  ) r(36) = press
    if ( present(pt)     ) r(37) = pt
    if ( present(pt_min) ) r(38) = pt_min
    if ( present(pt_max) ) r(39) = pt_max
    if ( present(tt)     ) r(40) = tt
    if ( present(temp)   ) r(41) = temp
    if ( present(tt_rms) ) r(42) = tt_rms
    if ( present(rho)    ) r(43) = rho
    if ( present(area)   ) r(44) = area

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    clp  = s(01)
    cdp  = s(02)
    clv  = s(03)
    cdv  = s(04)

    cmxp = s(05)
    cmyp = s(06)
    cmzp = s(07)
    cmxv = s(08)
    cmyv = s(09)
    cmzv = s(10)

    cxp  = s(11)
    cyp  = s(12)
    czp  = s(13)
    cxv  = s(14)
    cyv  = s(15)
    czv  = s(16)

    cl   = s(17)
    cd   = s(18)
    cmx  = s(19)
    cmy  = s(20)
    cmz  = s(21)
    cx   = s(22)
    cy   = s(23)
    cz   = s(24)
    heat = s(25)
    powerx= s(26)
    powery= s(27)
    powerz= s(28)

    if ( present(mass)   ) mass   = s(29)
    if ( present(momx)   ) momx   = s(30)
    if ( present(momy)   ) momy   = s(31)
    if ( present(momz)   ) momz   = s(32)
    if ( present(delpx)  ) delpx  = s(33)
    if ( present(delpy)  ) delpy  = s(34)
    if ( present(delpz)  ) delpz  = s(35)
    if ( present(press)  ) press  = s(36)
    if ( present(pt)     ) pt     = s(37)
    if ( present(pt_min) ) pt_min = s(38)
    if ( present(pt_max) ) pt_max = s(39)
    if ( present(tt)     ) tt     = s(40)
    if ( present(temp)   ) temp   = s(41)
    if ( present(tt_rms) ) tt_rms = s(42)
    if ( present(rho)    ) rho    = s(43)
    if ( present(area)   ) area   = s(44)

  end subroutine cmpxr8_collect_forces

!tempStartExpand(lmpi_collect_mflux)
!============================= integr_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine integr_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    integer(system_i4), intent(inout) :: mflux_integral,                       &
                               eflux_integral,                                 &
                               weflux_integral

    integer(system_i4), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine integr_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= integ8_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine integ8_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    integer(system_i8), intent(inout) :: mflux_integral,                       &
                               eflux_integral,                                 &
                               weflux_integral

    integer(system_i8), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine integ8_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= integ1_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine integ1_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    integer(system_i1), intent(inout) :: mflux_integral,                       &
                               eflux_integral,                                 &
                               weflux_integral

    integer(system_i1), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine integ1_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= logicl_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine logicl_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    logical, intent(inout) :: mflux_integral,                                  &
                               eflux_integral,                                 &
                               weflux_integral

    logical, dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine logicl_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= single_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine single_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    real(system_r4), intent(inout) :: mflux_integral,                          &
                               eflux_integral,                                 &
                               weflux_integral

    real(system_r4), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine single_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= double_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine double_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    real(system_r8), intent(inout) :: mflux_integral,                          &
                               eflux_integral,                                 &
                               weflux_integral

    real(system_r8), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine double_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= cmpxr4_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine cmpxr4_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    complex(system_r4), intent(inout) :: mflux_integral,                       &
                               eflux_integral,                                 &
                               weflux_integral

    complex(system_r4), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine cmpxr4_collect_mflux
!tempStartExpand(lmpi_collect_mflux)
!============================= cmpxr8_COLLECT_MFLUX
!
! Collects local force contributions to global flux from each processor
! (public)
!
!=============================================================================80
  subroutine cmpxr8_collect_mflux(mflux_integral, eflux_integral,              &
                                    weflux_integral )

    complex(system_r8), intent(inout) :: mflux_integral,                       &
                               eflux_integral,                                 &
                               weflux_integral

    complex(system_r8), dimension (3) :: r,s

    continue

    r(1) =  mflux_integral
    r(2) =  eflux_integral
    r(3) = weflux_integral

    call lmpi_reduce(r,s)

    call lmpi_bcast(s)

    mflux_integral  = s(1)
    eflux_integral  = s(2)
    weflux_integral = s(3)

  end subroutine cmpxr8_collect_mflux


!tempStartExpand(lmpi_xfer)
!=============================== integr_vector_xfer
!
! non-blocking send/receive pair for rank 1 integr data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    integer(system_i4),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    integer(system_i4),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine integr_vector_xfer

!=============================== integr_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integr nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    integer(system_i4),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    integer(system_i4),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine integr_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== integ8_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    integer(system_i8),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    integer(system_i8),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine integ8_vector_xfer

!=============================== integ8_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ8 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    integer(system_i8),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    integer(system_i8),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine integ8_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== integ1_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ1 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    integer(system_i1),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    integer(system_i1),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine integ1_vector_xfer

!=============================== integ1_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ1 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    integer(system_i1),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    integer(system_i1),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine integ1_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== logicl_vector_xfer
!
! non-blocking send/receive pair for rank 1 logicl data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    logical,            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    logical,       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine logicl_vector_xfer

!=============================== logicl_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 logicl nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    logical,         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    logical,    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine logicl_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== single_vector_xfer
!
! non-blocking send/receive pair for rank 1 single data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    real(system_r4),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    real(system_r4),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine single_vector_xfer

!=============================== single_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 single nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    real(system_r4),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    real(system_r4),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine single_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== double_vector_xfer
!
! non-blocking send/receive pair for rank 1 double data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    real(system_r8),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    real(system_r8),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine double_vector_xfer

!=============================== double_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 double nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    real(system_r8),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    real(system_r8),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine double_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== cmpxr4_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr4 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    complex(system_r4),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    complex(system_r4),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine cmpxr4_vector_xfer

!=============================== cmpxr4_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    complex(system_r4),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    complex(system_r4),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine cmpxr4_matrix_xfer
!tempStartExpand(lmpi_xfer)
!=============================== cmpxr8_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_vector_xfer(data, ghostlevel_arg, site, sr_opt, output)

    complex(system_r8),            dimension(:), intent(inout) :: data
    integer,             optional,     intent(in)    :: ghostlevel_arg
    character(*),        optional,     intent(in)    :: site
    type(sendrecv_type), optional,     intent(in)    :: sr_opt
    complex(system_r8),       optional, dimension(:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine cmpxr8_vector_xfer

!=============================== cmpxr8_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_matrix_xfer(data, ghostlevel_arg, site, sr_opt, output)

    complex(system_r8),         dimension(:,:), intent(inout) :: data
    integer,             optional,    intent(in)    :: ghostlevel_arg
    character(*),        optional,    intent(in)    :: site
    type(sendrecv_type), optional,    intent(in)    :: sr_opt
    complex(system_r8),    optional, dimension(:,:), intent(inout) :: output

    continue

    call lmpi_start_xfer(data, ghostlevel_arg, site, sr_opt)
    call lmpi_complete_xfer(data, ghostlevel_arg, site, sr_opt, output)

  end subroutine cmpxr8_matrix_xfer

!tempStartExpand(lmpi_put)
!=============================== integr_vector_put
!
! non-blocking send/receive pair for rank 1 integr data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integr_vector_put(data1, data2, sr, site )

    integer(system_i4), dimension(:), intent(in)    :: data1
    integer(system_i4), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine integr_vector_put

!=============================== integr_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 integr data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integr_matrix_put(data1, data2, sr, site )

    integer(system_i4), dimension(:,:), intent(in)    :: data1
    integer(system_i4), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine integr_matrix_put
!tempStartExpand(lmpi_put)
!=============================== integ8_vector_put
!
! non-blocking send/receive pair for rank 1 integ8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ8_vector_put(data1, data2, sr, site )

    integer(system_i8), dimension(:), intent(in)    :: data1
    integer(system_i8), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine integ8_vector_put

!=============================== integ8_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 integ8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ8_matrix_put(data1, data2, sr, site )

    integer(system_i8), dimension(:,:), intent(in)    :: data1
    integer(system_i8), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine integ8_matrix_put
!tempStartExpand(lmpi_put)
!=============================== integ1_vector_put
!
! non-blocking send/receive pair for rank 1 integ1 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ1_vector_put(data1, data2, sr, site )

    integer(system_i1), dimension(:), intent(in)    :: data1
    integer(system_i1), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine integ1_vector_put

!=============================== integ1_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 integ1 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ1_matrix_put(data1, data2, sr, site )

    integer(system_i1), dimension(:,:), intent(in)    :: data1
    integer(system_i1), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine integ1_matrix_put
!tempStartExpand(lmpi_put)
!=============================== logicl_vector_put
!
! non-blocking send/receive pair for rank 1 logicl data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine logicl_vector_put(data1, data2, sr, site )

    logical, dimension(:), intent(in)    :: data1
    logical, dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine logicl_vector_put

!=============================== logicl_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 logicl data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine logicl_matrix_put(data1, data2, sr, site )

    logical, dimension(:,:), intent(in)    :: data1
    logical, dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine logicl_matrix_put
!tempStartExpand(lmpi_put)
!=============================== single_vector_put
!
! non-blocking send/receive pair for rank 1 single data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine single_vector_put(data1, data2, sr, site )

    real(system_r4), dimension(:), intent(in)    :: data1
    real(system_r4), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine single_vector_put

!=============================== single_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 single data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine single_matrix_put(data1, data2, sr, site )

    real(system_r4), dimension(:,:), intent(in)    :: data1
    real(system_r4), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine single_matrix_put
!tempStartExpand(lmpi_put)
!=============================== double_vector_put
!
! non-blocking send/receive pair for rank 1 double data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine double_vector_put(data1, data2, sr, site )

    real(system_r8), dimension(:), intent(in)    :: data1
    real(system_r8), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine double_vector_put

!=============================== double_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 double data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine double_matrix_put(data1, data2, sr, site )

    real(system_r8), dimension(:,:), intent(in)    :: data1
    real(system_r8), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine double_matrix_put
!tempStartExpand(lmpi_put)
!=============================== cmpxr4_vector_put
!
! non-blocking send/receive pair for rank 1 cmpxr4 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr4_vector_put(data1, data2, sr, site )

    complex(system_r4), dimension(:), intent(in)    :: data1
    complex(system_r4), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine cmpxr4_vector_put

!=============================== cmpxr4_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr4_matrix_put(data1, data2, sr, site )

    complex(system_r4), dimension(:,:), intent(in)    :: data1
    complex(system_r4), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine cmpxr4_matrix_put
!tempStartExpand(lmpi_put)
!=============================== cmpxr8_vector_put
!
! non-blocking send/receive pair for rank 1 cmpxr8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr8_vector_put(data1, data2, sr, site )

    complex(system_r8), dimension(:), intent(in)    :: data1
    complex(system_r8), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine cmpxr8_vector_put

!=============================== cmpxr8_matrix_put
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr8_matrix_put(data1, data2, sr, site )

    complex(system_r8), dimension(:,:), intent(in)    :: data1
    complex(system_r8), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_end_xfer(data2, sr, site)

  end subroutine cmpxr8_matrix_put

!tempStartExpand(lmpi_add)
!=============================== integr_vector_add
!
! non-blocking send/receive pair for rank 1 integr data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integr_vector_add(data1, data2, sr, site)

    integer(system_i4), dimension(:), intent(in)    :: data1
    integer(system_i4), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine integr_vector_add

!=============================== integr_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 integr data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integr_matrix_add(data1, data2, sr, site )

    integer(system_i4), dimension(:,:), intent(in)    :: data1
    integer(system_i4), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine integr_matrix_add
!tempStartExpand(lmpi_add)
!=============================== integ8_vector_add
!
! non-blocking send/receive pair for rank 1 integ8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ8_vector_add(data1, data2, sr, site)

    integer(system_i8), dimension(:), intent(in)    :: data1
    integer(system_i8), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine integ8_vector_add

!=============================== integ8_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 integ8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ8_matrix_add(data1, data2, sr, site )

    integer(system_i8), dimension(:,:), intent(in)    :: data1
    integer(system_i8), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine integ8_matrix_add
!tempStartExpand(lmpi_add)
!=============================== integ1_vector_add
!
! non-blocking send/receive pair for rank 1 integ1 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ1_vector_add(data1, data2, sr, site)

    integer(system_i1), dimension(:), intent(in)    :: data1
    integer(system_i1), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine integ1_vector_add

!=============================== integ1_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 integ1 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine integ1_matrix_add(data1, data2, sr, site )

    integer(system_i1), dimension(:,:), intent(in)    :: data1
    integer(system_i1), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine integ1_matrix_add
!tempStartExpand(lmpi_add)
!=============================== logicl_vector_add
!
! non-blocking send/receive pair for rank 1 logicl data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine logicl_vector_add(data1, data2, sr, site)

    logical, dimension(:), intent(in)    :: data1
    logical, dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine logicl_vector_add

!=============================== logicl_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 logicl data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine logicl_matrix_add(data1, data2, sr, site )

    logical, dimension(:,:), intent(in)    :: data1
    logical, dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine logicl_matrix_add
!tempStartExpand(lmpi_add)
!=============================== single_vector_add
!
! non-blocking send/receive pair for rank 1 single data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine single_vector_add(data1, data2, sr, site)

    real(system_r4), dimension(:), intent(in)    :: data1
    real(system_r4), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine single_vector_add

!=============================== single_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 single data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine single_matrix_add(data1, data2, sr, site )

    real(system_r4), dimension(:,:), intent(in)    :: data1
    real(system_r4), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine single_matrix_add
!tempStartExpand(lmpi_add)
!=============================== double_vector_add
!
! non-blocking send/receive pair for rank 1 double data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine double_vector_add(data1, data2, sr, site)

    real(system_r8), dimension(:), intent(in)    :: data1
    real(system_r8), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine double_vector_add

!=============================== double_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 double data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine double_matrix_add(data1, data2, sr, site )

    real(system_r8), dimension(:,:), intent(in)    :: data1
    real(system_r8), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine double_matrix_add
!tempStartExpand(lmpi_add)
!=============================== cmpxr4_vector_add
!
! non-blocking send/receive pair for rank 1 cmpxr4 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr4_vector_add(data1, data2, sr, site)

    complex(system_r4), dimension(:), intent(in)    :: data1
    complex(system_r4), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine cmpxr4_vector_add

!=============================== cmpxr4_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr4_matrix_add(data1, data2, sr, site )

    complex(system_r4), dimension(:,:), intent(in)    :: data1
    complex(system_r4), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine cmpxr4_matrix_add
!tempStartExpand(lmpi_add)
!=============================== cmpxr8_vector_add
!
! non-blocking send/receive pair for rank 1 cmpxr8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr8_vector_add(data1, data2, sr, site)

    complex(system_r8), dimension(:), intent(in)    :: data1
    complex(system_r8), dimension(:), intent(inout) :: data2
    type(sendrecv_type),    intent(inout) :: sr
    character(*),        optional,     intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine cmpxr8_vector_add

!=============================== cmpxr8_matrix_add
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8 data
! (private)
!
! used to put a local array into off-processor arrays.
!
!=============================================================================80

  subroutine cmpxr8_matrix_add(data1, data2, sr, site )

    complex(system_r8), dimension(:,:), intent(in)    :: data1
    complex(system_r8), dimension(:,:), intent(inout) :: data2
    type(sendrecv_type),      intent(inout) :: sr
    character(*),        optional,    intent(in)    :: site

    continue

    call lmpi_sta_xfer(data1, sr, site)
    call lmpi_enda_xfer(data2, sr, site)

  end subroutine cmpxr8_matrix_add


!tempStartExpand(lmpi_start_xfer)
!=============================== integr_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 integr data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    integer(system_i4),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%integr_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%integr_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%integr_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%integr_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%integr_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%integr_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_integer, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integr_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integr_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%integr_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%integr_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integr_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integr_start_vector_xfer

!=============================== integr_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integr nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    integer(system_i4),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%integr_mat_allocated ) then
      nallocdim = size(sr_loc%integr_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%integr_mat_recvdata)
        deallocate(sr_loc%integr_mat_senddata)

        allocate(sr_loc%integr_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integr_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%integr_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integr_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%integr_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%integr_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%integr_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%integr_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%integr_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_integer,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integr_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (integr_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%integr_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%integr_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (integr_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integr_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== integ8_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    integer(system_i8),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%integ8_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%integ8_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%integ8_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%integ8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%integ8_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%integ8_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_integer8, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ8_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ8_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%integ8_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%integ8_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integ8_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ8_start_vector_xfer

!=============================== integ8_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ8 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    integer(system_i8),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%integ8_mat_allocated ) then
      nallocdim = size(sr_loc%integ8_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%integ8_mat_recvdata)
        deallocate(sr_loc%integ8_mat_senddata)

        allocate(sr_loc%integ8_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integ8_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%integ8_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integ8_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%integ8_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%integ8_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%integ8_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%integ8_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%integ8_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_integer8,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ8_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (integ8_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%integ8_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%integ8_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (integ8_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ8_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== integ1_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ1 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    integer(system_i1),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%integ1_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%integ1_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%integ1_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%integ1_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%integ1_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%integ1_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_byte, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ1_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ1_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%integ1_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%integ1_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integ1_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ1_start_vector_xfer

!=============================== integ1_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ1 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    integer(system_i1),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%integ1_mat_allocated ) then
      nallocdim = size(sr_loc%integ1_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%integ1_mat_recvdata)
        deallocate(sr_loc%integ1_mat_senddata)

        allocate(sr_loc%integ1_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integ1_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%integ1_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integ1_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%integ1_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%integ1_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%integ1_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%integ1_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%integ1_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_byte,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ1_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (integ1_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%integ1_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%integ1_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (integ1_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ1_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== logicl_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 logicl data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    logical,      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%logicl_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%logicl_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%logicl_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%logicl_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%logicl_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%logicl_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_logical, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (logicl_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (logicl_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%logicl_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%logicl_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (logicl_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine logicl_start_vector_xfer

!=============================== logicl_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 logicl nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    logical,    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%logicl_mat_allocated ) then
      nallocdim = size(sr_loc%logicl_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%logicl_mat_recvdata)
        deallocate(sr_loc%logicl_mat_senddata)

        allocate(sr_loc%logicl_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(logicl_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%logicl_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re logicl_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%logicl_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%logicl_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%logicl_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%logicl_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%logicl_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_logical,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (logicl_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (logicl_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%logicl_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%logicl_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (logicl_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine logicl_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== single_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 single data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    real(system_r4),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%single_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%single_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%single_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%single_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%single_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%single_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_real, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (single_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (single_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%single_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%single_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (single_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine single_start_vector_xfer

!=============================== single_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 single nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    real(system_r4),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%single_mat_allocated ) then
      nallocdim = size(sr_loc%single_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%single_mat_recvdata)
        deallocate(sr_loc%single_mat_senddata)

        allocate(sr_loc%single_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(single_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%single_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re single_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%single_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%single_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%single_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%single_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%single_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_real,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (single_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (single_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%single_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%single_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (single_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine single_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== double_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 double data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    real(system_r8),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%double_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%double_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%double_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%double_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%double_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%double_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_double_precision, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (double_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (double_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%double_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%double_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (double_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine double_start_vector_xfer

!=============================== double_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 double nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    real(system_r8),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%double_mat_allocated ) then
      nallocdim = size(sr_loc%double_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%double_mat_recvdata)
        deallocate(sr_loc%double_mat_senddata)

        allocate(sr_loc%double_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(double_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%double_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re double_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%double_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%double_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%double_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%double_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%double_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_double_precision,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (double_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (double_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%double_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%double_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (double_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine double_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== cmpxr4_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr4 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    complex(system_r4),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%cmpxr4_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%cmpxr4_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%cmpxr4_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%cmpxr4_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%cmpxr4_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%cmpxr4_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_complex, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr4_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr4_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%cmpxr4_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%cmpxr4_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (cmpxr4_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr4_start_vector_xfer

!=============================== cmpxr4_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    complex(system_r4),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%cmpxr4_mat_allocated ) then
      nallocdim = size(sr_loc%cmpxr4_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%cmpxr4_mat_recvdata)
        deallocate(sr_loc%cmpxr4_mat_senddata)

        allocate(sr_loc%cmpxr4_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(cmpxr4_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%cmpxr4_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re cmpxr4_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%cmpxr4_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%cmpxr4_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%cmpxr4_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%cmpxr4_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%cmpxr4_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_complex,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr4_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (cmpxr4_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%cmpxr4_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%cmpxr4_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (cmpxr4_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr4_start_matrix_xfer

!tempStartExpand(lmpi_start_xfer)
!=============================== cmpxr8_start_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_start_vector_xfer(data, ghostlevel_arg, site, sr_opt)

    complex(system_r8),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%cmpxr8_vec_allocated ) then

    else chk_alloc

      allocate(sr_loc%cmpxr8_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%cmpxr8_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_senddata(nleaddim,senddim)) failed"

      sr_loc%cmpxr8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%cmpxr8_vec_recvdata, length,                  &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%cmpxr8_vec_recvdata( &
        !      sr_loc%recvproc(i_other_proc+1) ),       &
        !      length, mpi_double_complex, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr8_start_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr8_start_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      sr_loc%cmpxr8_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr_loc%cmpxr8_vec_senddata,                         &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (cmpxr8_start_vector_xfer) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr8_start_vector_xfer

!=============================== cmpxr8_start_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_start_matrix_xfer(data, ghostlevel_arg, site, sr_opt )

    complex(system_r8),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(len=*),            optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr_loc%cmpxr8_mat_allocated ) then
      nallocdim = size(sr_loc%cmpxr8_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr_loc%cmpxr8_mat_recvdata)
        deallocate(sr_loc%cmpxr8_mat_senddata)

        allocate(sr_loc%cmpxr8_mat_recvdata(max(1,nleaddim),                   &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(cmpxr8_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr_loc%cmpxr8_mat_senddata(max(1,nleaddim),                   &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re cmpxr8_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr_loc%cmpxr8_mat_recvdata(max(1,nleaddim),                     &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr_loc%cmpxr8_mat_senddata(max(1,nleaddim),                     &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_mat_senddata(nleaddim,senddim)) failed"

      sr_loc%cmpxr8_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr_loc%recvproc(i_other_proc+2)                               &
               - sr_loc%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr_loc%cmpxr8_mat_recvdata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr_loc%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr_loc%cmpxr8_mat_recvdata(        &
        !      1, sr_loc%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_double_complex,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr8_start_matrix_xfer) failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
        inode = sr_loc%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (cmpxr8_start_matrix_xfer) failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr_loc%sendproc(lmpi_nproc+1) - 1
      inode = sr_loc%sendindex(inde)
      slead : do l = 1, nleaddim
        sr_loc%cmpxr8_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr_loc%sendproc(i_other_proc+2)                               &
               - sr_loc%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr_loc%cmpxr8_mat_senddata,                          &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr_loc%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (cmpxr8_start_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr8_start_matrix_xfer



!tempStartExpand(lmpi_xfer_fem)
!=============================== integr_xfer_fem
!
! non-blocking send/receive pair for rank 1 integr data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    integer(system_i4), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%integr_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integr_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%integr_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integr_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integr_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine integr_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== integ8_xfer_fem
!
! non-blocking send/receive pair for rank 1 integ8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    integer(system_i8), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%integ8_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ8_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%integ8_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integ8_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ8_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine integ8_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== integ1_xfer_fem
!
! non-blocking send/receive pair for rank 1 integ1 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    integer(system_i1), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%integ1_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ1_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%integ1_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integ1_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ1_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine integ1_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== logicl_xfer_fem
!
! non-blocking send/receive pair for rank 1 logicl data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    logical, intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%logicl_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (logicl_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%logicl_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (logicl_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (logicl_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine logicl_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== single_xfer_fem
!
! non-blocking send/receive pair for rank 1 single data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    real(system_r4), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%single_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (single_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%single_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (single_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (single_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine single_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== double_xfer_fem
!
! non-blocking send/receive pair for rank 1 double data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    real(system_r8), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%double_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (double_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%double_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (double_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (double_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine double_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== cmpxr4_xfer_fem
!
! non-blocking send/receive pair for rank 1 cmpxr4 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    complex(system_r4), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%cmpxr4_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr4_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%cmpxr4_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (cmpxr4_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr4_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine cmpxr4_xfer_fem
!tempStartExpand(lmpi_xfer_fem)
!=============================== cmpxr8_xfer_fem
!
! non-blocking send/receive pair for rank 1 cmpxr8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_xfer_fem(recvlength, sendlength, sr_in,                    &
                               representative_data, nvars)

    integer, intent(in) :: nvars

    integer, dimension(:), intent(in) :: recvlength, sendlength

! to disambiguate interface:

    complex(system_r8), intent(in) :: representative_data

    type(sendrecv_type), intent(inout) :: sr_in

#ifdef HAVE_MPI
    integer :: ierr                ! error flag
    integer :: startval            ! error flag
    integer :: mpitag              ! unique message tag
    integer :: i_other_proc        ! processor loop index
#endif

    continue

    if ( .false. ) write(*,*) representative_data

#ifdef HAVE_MPI

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        rlen : if (recvlength(i_other_proc+1)>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          startval = nvars*(sr_in%recvproc(i_other_proc+1)-1) + 1

          call lmpi_irecv(sr_in%cmpxr8_vec_recvdata,                           &
                          recvlength(i_other_proc+1),                          &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 startval)
!                1)
!                3*sr_in%recvproc(i_other_proc+1))
!                sr_in%recvproc(i_other_proc+1)) ! original

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr8_xfer_fem) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend = 0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        slen : if (sendlength(i_other_proc+1)>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          startval = nvars*(sr_in%sendproc(i_other_proc+1)-1) + 1

          call lmpi_isend( sr_in%cmpxr8_vec_senddata,                          &
               sendlength(i_other_proc+1), i_other_proc, mpitag,               &
               sendreq(nsend), ierr,                                           &
               startval)
!              1)
!              3*sr_in%sendproc(i_other_proc+1))
!              sr_in%sendproc(i_other_proc+1)) ! original

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (cmpxr8_xfer_fem) failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi communication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait lmpi_xfer_fem failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr8_xfer_fem) failed..."
      return
    endif wait_recv_error

#else
! avoid compiler warnings
    if (.false.) write(*,*) recvlength(1), sendlength(1),                      &
                            sr_in%size_sendindex, nvars
#endif

  end subroutine cmpxr8_xfer_fem


!tempStartExpand(lmpi_complete_xfer)
!=============================== integr_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 integr data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    integer(system_i4),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    integer(system_i4),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integr_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integr_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integr_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%integr_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%integr_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integr_complete_vector_xfer

!=============================== integr_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integr nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integr_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    integer(system_i4),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    integer(system_i4),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integr_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integr_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integr_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%integr_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%integr_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integr_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== integ8_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    integer(system_i8),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    integer(system_i8),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integ8_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ8_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ8_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%integ8_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%integ8_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ8_complete_vector_xfer

!=============================== integ8_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ8 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ8_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    integer(system_i8),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    integer(system_i8),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ8_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ8_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integ8_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%integ8_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%integ8_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ8_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== integ1_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ1 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    integer(system_i1),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    integer(system_i1),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integ1_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ1_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ1_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%integ1_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%integ1_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ1_complete_vector_xfer

!=============================== integ1_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ1 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine integ1_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    integer(system_i1),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    integer(system_i1),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ1_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ1_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integ1_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%integ1_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%integ1_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine integ1_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== logicl_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 logicl data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    logical,      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    logical,      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (logicl_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (logicl_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (logicl_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%logicl_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%logicl_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine logicl_complete_vector_xfer

!=============================== logicl_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 logicl nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine logicl_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    logical,    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    logical,    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send logicl_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv logicl_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(logicl_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%logicl_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%logicl_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine logicl_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== single_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 single data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    real(system_r4),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    real(system_r4),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (single_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (single_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (single_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%single_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%single_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine single_complete_vector_xfer

!=============================== single_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 single nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine single_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    real(system_r4),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    real(system_r4),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send single_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv single_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(single_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%single_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%single_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine single_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== double_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 double data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    real(system_r8),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    real(system_r8),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (double_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (double_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (double_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%double_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%double_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine double_complete_vector_xfer

!=============================== double_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 double nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine double_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    real(system_r8),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    real(system_r8),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send double_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv double_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(double_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%double_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%double_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine double_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== cmpxr4_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr4 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    complex(system_r4),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    complex(system_r4),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (cmpxr4_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr4_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr4_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%cmpxr4_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%cmpxr4_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr4_complete_vector_xfer

!=============================== cmpxr4_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr4_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    complex(system_r4),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    complex(system_r4),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr4_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr4_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(cmpxr4_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%cmpxr4_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%cmpxr4_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr4_matrix_complete_xfer
!tempStartExpand(lmpi_complete_xfer)
!=============================== cmpxr8_complete_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr8 data on nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_complete_vector_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    complex(system_r8),      dimension(:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    complex(system_r8),      dimension(:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: lvl                 ! mpi ghost node level
    integer :: size_allowed        ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,1), site )
    endif

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (cmpxr8_complete_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr8_complete_vector_xfer) failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr8_complete_vector_xfer) failed lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        output(inode) = sr_loc%cmpxr8_vec_recvdata(inde)
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        data(inode) = sr_loc%cmpxr8_vec_recvdata(inde)
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr8_complete_vector_xfer

!=============================== cmpxr8_complete_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8 nodes
! (private)
!
! used to share a local array with all the other nodes to fill partition
! boundary ghost nodes.
!
!=============================================================================80

  subroutine cmpxr8_matrix_complete_xfer(data, ghostlevel_arg, site, sr_opt,   &
                                           output)

    complex(system_r8),    dimension(:,:),           intent(inout) :: data
    integer,                     optional, intent(in)    :: ghostlevel_arg
    character(*),                optional, intent(in)    :: site
    type(sendrecv_type), target, optional, intent(in)    :: sr_opt
    complex(system_r8),    dimension(:,:), optional, intent(inout) :: output

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: lvl            ! mpi ghost level to transfer
    integer :: size_allowed   ! allowable size of the array
#endif

    type(sendrecv_type), pointer :: sr_loc

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )

! Point a local pointer to the specific sr we want to use for the xfer

    if ( present(sr_opt) ) then
      sr_loc => sr_opt
    else
      sr_loc => sr(lvl)
      if ( check_xfer01 ) call check_size01( size(data,2), site )
    endif

    errc         = 0

    senddim  = sr_loc%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr_loc%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr8_matrix_complete_xfer failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr8_matrix_complete_xfer failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(cmpxr8_matrix_complete_xfer)failed...lvl=',lvl
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    if ( present(output) ) then
      rindex2 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead2 : do l = 1, nleaddim
          output(l,inode) = sr_loc%cmpxr8_mat_recvdata(l,inde)
        enddo rlead2
      enddo rindex2
    else
      rindex1 : do inde = 1, sr_loc%recvproc(lmpi_nproc+1) - 1
        inode = sr_loc%recvindex(inde)
        rlead1 : do l = 1, nleaddim
          data(l,inode) = sr_loc%cmpxr8_mat_recvdata(l,inde)
        enddo rlead1
      enddo rindex1
    endif

#else
! avoid compiler warnings
    if (present(sr_opt)) sr_loc => sr_opt
    if (present(output)) then
      if (.false.) write(*,*) output(1,1)
    endif
    if (.false.) write(*,*) ghostlevel_arg, data, site, sr_loc%size_sendindex
#endif

  end subroutine cmpxr8_matrix_complete_xfer


!tempStartExpand(lmpi_sta_xfer)
!=============================== integr_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 integr data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine integr_sta_vector_xfer(data, sr, site)

    integer(system_i4),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%integr_vec_allocated ) then

    else chk_alloc

      allocate(sr%integr_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%integr_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_senddata(nleaddim,senddim)) failed"

      sr%integr_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%integr_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%integr_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_integer, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integr_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integr_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%integr_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%integr_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integr_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integr_sta_vector_xfer

!=============================== integr_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integr
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine integr_sta_matrix_xfer(data, sr, site )

    integer(system_i4),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%integr_mat_allocated ) then
      nallocdim = size(sr%integr_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%integr_mat_recvdata)
        deallocate(sr%integr_mat_senddata)

        allocate(sr%integr_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integr_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%integr_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integr_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%integr_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%integr_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_mat_senddata(nleaddim,senddim)) failed"

      sr%integr_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%integr_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%integr_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_integer,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integr_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (integr_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%integr_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%integr_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (integr_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integr_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== integ8_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ8 data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine integ8_sta_vector_xfer(data, sr, site)

    integer(system_i8),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%integ8_vec_allocated ) then

    else chk_alloc

      allocate(sr%integ8_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%integ8_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_senddata(nleaddim,senddim)) failed"

      sr%integ8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%integ8_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%integ8_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_integer8, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ8_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ8_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%integ8_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%integ8_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integ8_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ8_sta_vector_xfer

!=============================== integ8_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ8
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine integ8_sta_matrix_xfer(data, sr, site )

    integer(system_i8),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%integ8_mat_allocated ) then
      nallocdim = size(sr%integ8_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%integ8_mat_recvdata)
        deallocate(sr%integ8_mat_senddata)

        allocate(sr%integ8_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integ8_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%integ8_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integ8_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%integ8_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%integ8_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_mat_senddata(nleaddim,senddim)) failed"

      sr%integ8_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%integ8_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%integ8_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_integer8,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ8_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (integ8_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%integ8_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%integ8_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (integ8_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ8_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== integ1_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ1 data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine integ1_sta_vector_xfer(data, sr, site)

    integer(system_i1),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%integ1_vec_allocated ) then

    else chk_alloc

      allocate(sr%integ1_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%integ1_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_senddata(nleaddim,senddim)) failed"

      sr%integ1_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%integ1_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%integ1_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_byte, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ1_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ1_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%integ1_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%integ1_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (integ1_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ1_sta_vector_xfer

!=============================== integ1_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ1
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine integ1_sta_matrix_xfer(data, sr, site )

    integer(system_i1),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%integ1_mat_allocated ) then
      nallocdim = size(sr%integ1_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%integ1_mat_recvdata)
        deallocate(sr%integ1_mat_senddata)

        allocate(sr%integ1_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integ1_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%integ1_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integ1_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%integ1_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%integ1_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_mat_senddata(nleaddim,senddim)) failed"

      sr%integ1_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%integ1_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%integ1_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_byte,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (integ1_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (integ1_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%integ1_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%integ1_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (integ1_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ1_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== logicl_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 logicl data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine logicl_sta_vector_xfer(data, sr, site)

    logical,      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%logicl_vec_allocated ) then

    else chk_alloc

      allocate(sr%logicl_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%logicl_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_senddata(nleaddim,senddim)) failed"

      sr%logicl_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%logicl_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%logicl_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_logical, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (logicl_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (logicl_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%logicl_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%logicl_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (logicl_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine logicl_sta_vector_xfer

!=============================== logicl_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 logicl
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine logicl_sta_matrix_xfer(data, sr, site )

    logical,    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%logicl_mat_allocated ) then
      nallocdim = size(sr%logicl_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%logicl_mat_recvdata)
        deallocate(sr%logicl_mat_senddata)

        allocate(sr%logicl_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(logicl_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%logicl_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re logicl_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%logicl_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%logicl_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_mat_senddata(nleaddim,senddim)) failed"

      sr%logicl_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%logicl_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%logicl_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_logical,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (logicl_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (logicl_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%logicl_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%logicl_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (logicl_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine logicl_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== single_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 single data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine single_sta_vector_xfer(data, sr, site)

    real(system_r4),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%single_vec_allocated ) then

    else chk_alloc

      allocate(sr%single_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%single_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_senddata(nleaddim,senddim)) failed"

      sr%single_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%single_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%single_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_real, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (single_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (single_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%single_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%single_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (single_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine single_sta_vector_xfer

!=============================== single_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 single
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine single_sta_matrix_xfer(data, sr, site )

    real(system_r4),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%single_mat_allocated ) then
      nallocdim = size(sr%single_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%single_mat_recvdata)
        deallocate(sr%single_mat_senddata)

        allocate(sr%single_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(single_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%single_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re single_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%single_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%single_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_mat_senddata(nleaddim,senddim)) failed"

      sr%single_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%single_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%single_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_real,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (single_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (single_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%single_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%single_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (single_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine single_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== double_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 double data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine double_sta_vector_xfer(data, sr, site)

    real(system_r8),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%double_vec_allocated ) then

    else chk_alloc

      allocate(sr%double_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%double_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_senddata(nleaddim,senddim)) failed"

      sr%double_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%double_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%double_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_double_precision, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (double_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (double_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%double_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%double_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (double_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine double_sta_vector_xfer

!=============================== double_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 double
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine double_sta_matrix_xfer(data, sr, site )

    real(system_r8),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%double_mat_allocated ) then
      nallocdim = size(sr%double_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%double_mat_recvdata)
        deallocate(sr%double_mat_senddata)

        allocate(sr%double_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(double_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%double_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re double_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%double_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%double_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_mat_senddata(nleaddim,senddim)) failed"

      sr%double_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%double_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%double_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_double_precision,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (double_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (double_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%double_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%double_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (double_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine double_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== cmpxr4_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr4 data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine cmpxr4_sta_vector_xfer(data, sr, site)

    complex(system_r4),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%cmpxr4_vec_allocated ) then

    else chk_alloc

      allocate(sr%cmpxr4_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%cmpxr4_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_senddata(nleaddim,senddim)) failed"

      sr%cmpxr4_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%cmpxr4_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%cmpxr4_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_complex, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr4_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr4_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%cmpxr4_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%cmpxr4_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (cmpxr4_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr4_sta_vector_xfer

!=============================== cmpxr4_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine cmpxr4_sta_matrix_xfer(data, sr, site )

    complex(system_r4),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%cmpxr4_mat_allocated ) then
      nallocdim = size(sr%cmpxr4_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%cmpxr4_mat_recvdata)
        deallocate(sr%cmpxr4_mat_senddata)

        allocate(sr%cmpxr4_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(cmpxr4_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%cmpxr4_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re cmpxr4_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%cmpxr4_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%cmpxr4_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_mat_senddata(nleaddim,senddim)) failed"

      sr%cmpxr4_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%cmpxr4_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%cmpxr4_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_complex,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr4_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (cmpxr4_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%cmpxr4_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%cmpxr4_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (cmpxr4_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr4_sta_matrix_xfer

!tempStartExpand(lmpi_sta_xfer)
!=============================== cmpxr8_sta_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr8 data
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine cmpxr8_sta_vector_xfer(data, sr, site)

    complex(system_r8),      dimension(:),  intent(in)     :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(*),       optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: mpitag, length      ! unique message tag and length
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: i_other_proc        ! processor loop index
    integer :: astat               ! allocation status
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%cmpxr8_vec_allocated ) then

    else chk_alloc

      allocate(sr%cmpxr8_vec_recvdata(max(1,recvdim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%cmpxr8_vec_senddata(max(1,senddim)), stat = astat)
      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_senddata(nleaddim,senddim)) failed"

      sr%cmpxr8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 1 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%cmpxr8_vec_recvdata, length,                      &
                 i_other_proc, mpitag, recvreq(nrecv), ierr,                   &
                 sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%cmpxr8_vec_recvdata( &
        !      sr%recvproc(i_other_proc+1) ),       &
        !      length, mpi_double_complex, i_other_proc, mpitag,   &
        !      lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr8_sta_vector_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node inforvection to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr8_sta_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      sr%cmpxr8_vec_senddata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 1 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend( sr%cmpxr8_vec_senddata,                             &
               length, i_other_proc, mpitag,                                   &
               sendreq(nsend), ierr,                                           &
               sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in (cmpxr8_sta_vector_xfer) failed"
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr8_sta_vector_xfer

!=============================== cmpxr8_sta_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8
! (private)
!
! used to share a local array.
!
!=============================================================================80

  subroutine cmpxr8_sta_matrix_xfer(data, sr, site )

    complex(system_r8),    dimension(:,:),  intent(in)    :: data
    type(sendrecv_type),          intent(inout) :: sr
    character(len=*),   optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr%cmpxr8_mat_allocated ) then
      nallocdim = size(sr%cmpxr8_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr%cmpxr8_mat_recvdata)
        deallocate(sr%cmpxr8_mat_senddata)

        allocate(sr%cmpxr8_mat_recvdata(max(1,nleaddim),                       &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(cmpxr8_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr%cmpxr8_mat_senddata(max(1,nleaddim),                       &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re cmpxr8_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader
    else chk_alloc

      nallocdim = nleaddim

      allocate(sr%cmpxr8_mat_recvdata(max(1,nleaddim),                         &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr%cmpxr8_mat_senddata(max(1,nleaddim),                         &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_mat_senddata(nleaddim,senddim)) failed"

      sr%cmpxr8_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr%recvproc(i_other_proc+2)                                   &
               - sr%recvproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 2 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

          call lmpi_irecv(sr%cmpxr8_mat_recvdata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, recvreq(nrecv), ierr,                     &
               1, sr%recvproc(i_other_proc+1))

        ! call mpi_irecv( sr%cmpxr8_mat_recvdata(        &
        !      1, sr%recvproc(i_other_proc+1) ),           &
        !      length*nallocdim, mpi_double_complex,                      &
        !      i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv (cmpxr8_sta_matrix_xfer) failed"
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    if(check_xfer) then

      sindex_check : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
        inode = sr%sendindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' sindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer (cmpxr8_sta_matrix_xfer) failed...'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit sindex_check
        endif
      enddo sindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    sindex : do inde = 1, sr%sendproc(lmpi_nproc+1) - 1
      inode = sr%sendindex(inde)
      slead : do l = 1, nleaddim
        sr%cmpxr8_mat_senddata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr%sendproc(i_other_proc+2)                                   &
               - sr%sendproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 2 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

          call lmpi_isend(sr%cmpxr8_mat_senddata,                              &
               length*nallocdim,                                               &
               i_other_proc, mpitag, sendreq(nsend), ierr,                     &
               1, sr%sendproc(i_other_proc+1))

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend (cmpxr8_sta_matrix_xfer) failed..."
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

    ! call lmpi_complete_xfer to finish

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr8_sta_matrix_xfer


!tempStartExpand(lmpi_end_xfer)
!=============================== integr_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 integr data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integr_end_vector_xfer(data, sr, site)

    integer(system_i4),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integr_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integr_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integr_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%integr_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integr_end_vector_xfer

!=============================== integr_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integr
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integr_matrix_end_xfer(data, sr, site )

    integer(system_i4),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integr_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integr_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integr_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%integr_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integr_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== integ8_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ8 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ8_end_vector_xfer(data, sr, site)

    integer(system_i8),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integ8_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ8_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ8_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%integ8_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ8_end_vector_xfer

!=============================== integ8_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ8
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ8_matrix_end_xfer(data, sr, site )

    integer(system_i8),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ8_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ8_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integ8_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%integ8_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ8_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== integ1_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ1 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ1_end_vector_xfer(data, sr, site)

    integer(system_i1),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integ1_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ1_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ1_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%integ1_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ1_end_vector_xfer

!=============================== integ1_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ1
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ1_matrix_end_xfer(data, sr, site )

    integer(system_i1),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ1_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ1_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integ1_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%integ1_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ1_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== logicl_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 logicl data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine logicl_end_vector_xfer(data, sr, site)

    logical,      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (logicl_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (logicl_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (logicl_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%logicl_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine logicl_end_vector_xfer

!=============================== logicl_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 logicl
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine logicl_matrix_end_xfer(data, sr, site )

    logical,    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send logicl_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv logicl_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(logicl_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%logicl_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine logicl_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== single_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 single data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine single_end_vector_xfer(data, sr, site)

    real(system_r4),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (single_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (single_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (single_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%single_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine single_end_vector_xfer

!=============================== single_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 single
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine single_matrix_end_xfer(data, sr, site )

    real(system_r4),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send single_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv single_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(single_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%single_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine single_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== double_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 double data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine double_end_vector_xfer(data, sr, site)

    real(system_r8),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (double_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (double_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (double_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%double_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine double_end_vector_xfer

!=============================== double_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 double
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine double_matrix_end_xfer(data, sr, site )

    real(system_r8),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send double_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv double_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(double_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%double_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine double_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== cmpxr4_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr4 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr4_end_vector_xfer(data, sr, site)

    complex(system_r4),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (cmpxr4_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr4_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr4_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%cmpxr4_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr4_end_vector_xfer

!=============================== cmpxr4_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr4_matrix_end_xfer(data, sr, site )

    complex(system_r4),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr4_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr4_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(cmpxr4_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%cmpxr4_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr4_matrix_end_xfer
!tempStartExpand(lmpi_end_xfer)
!=============================== cmpxr8_end_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr8 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr8_end_vector_xfer(data, sr, site)

    complex(system_r8),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (cmpxr8_end_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr8_end_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr8_end_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = sr%cmpxr8_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr8_end_vector_xfer

!=============================== cmpxr8_end_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr8_matrix_end_xfer(data, sr, site )

    complex(system_r8),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr8_matrix_end_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr8_matrix_end_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(cmpxr8_matrix_end_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = sr%cmpxr8_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr8_matrix_end_xfer

!tempStartExpand(lmpi_enda_xfer)
!=============================== integr_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 integr data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integr_enda_vector_xfer(data, sr, site)

    integer(system_i4),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integr_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integr_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integr_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%integr_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integr_enda_vector_xfer

!=============================== integr_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integr
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integr_matrix_enda_xfer(data, sr, site )

    integer(system_i4),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integr_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integr_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integr_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%integr_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integr_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== integ8_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ8 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ8_enda_vector_xfer(data, sr, site)

    integer(system_i8),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integ8_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ8_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ8_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%integ8_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ8_enda_vector_xfer

!=============================== integ8_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ8
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ8_matrix_enda_xfer(data, sr, site )

    integer(system_i8),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ8_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ8_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integ8_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%integ8_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ8_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== integ1_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 integ1 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ1_enda_vector_xfer(data, sr, site)

    integer(system_i1),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (integ1_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (integ1_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (integ1_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%integ1_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ1_enda_vector_xfer

!=============================== integ1_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 integ1
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine integ1_matrix_enda_xfer(data, sr, site )

    integer(system_i1),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ1_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ1_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(integ1_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%integ1_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine integ1_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== logicl_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 logicl data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine logicl_enda_vector_xfer(data, sr, site)

    logical,      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (logicl_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (logicl_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (logicl_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%logicl_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine logicl_enda_vector_xfer

!=============================== logicl_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 logicl
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine logicl_matrix_enda_xfer(data, sr, site )

    logical,    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send logicl_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv logicl_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(logicl_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%logicl_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine logicl_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== single_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 single data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine single_enda_vector_xfer(data, sr, site)

    real(system_r4),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (single_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (single_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (single_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%single_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine single_enda_vector_xfer

!=============================== single_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 single
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine single_matrix_enda_xfer(data, sr, site )

    real(system_r4),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send single_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv single_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(single_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%single_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine single_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== double_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 double data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine double_enda_vector_xfer(data, sr, site)

    real(system_r8),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (double_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (double_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (double_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%double_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine double_enda_vector_xfer

!=============================== double_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 double
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine double_matrix_enda_xfer(data, sr, site )

    real(system_r8),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send double_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv double_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(double_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%double_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine double_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== cmpxr4_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr4 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr4_enda_vector_xfer(data, sr, site)

    complex(system_r4),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (cmpxr4_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr4_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr4_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%cmpxr4_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr4_enda_vector_xfer

!=============================== cmpxr4_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr4
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr4_matrix_enda_xfer(data, sr, site )

    complex(system_r4),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr4_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr4_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(cmpxr4_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%cmpxr4_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr4_matrix_enda_xfer
!tempStartExpand(lmpi_enda_xfer)
!=============================== cmpxr8_enda_vector_xfer
!
! non-blocking send/receive pair for rank 1 cmpxr8 data
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr8_enda_vector_xfer(data, sr, site)

    complex(system_r8),      dimension(:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site

#ifdef HAVE_MPI
    integer :: ierr, errc, errcm   ! communicator, error flags
    integer :: recvdim, senddim    ! extents of mpi work array
    integer :: inde, inode         ! mpi packing loop indexes
    integer :: size_allowed        ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI

    if (lmpi_nproc == 1) return ! mpi with one proc

    size_allowed = size( data , 1 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait (cmpxr8_enda_vector_xfer) failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in (cmpxr8_enda_vector_xfer) failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 1 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' (cmpxr8_enda_vector_xfer) failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      data(inode) = data(inode) + sr%cmpxr8_vec_recvdata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr8_enda_vector_xfer

!=============================== cmpxr8_enda_matrix_xfer
!
! Generic non-blocking send/receive pair for rank 2 cmpxr8
! (private)
!
! used to update data with data from other processors.
!
!=============================================================================80

  subroutine cmpxr8_matrix_enda_xfer(data, sr, site )

    complex(system_r8),    dimension(:,:),           intent(inout) :: data
    type(sendrecv_type),                   intent(in)    :: sr
    character(*),                optional, intent(in)    :: site


#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: errc, errcm    ! communicator, error flag
    integer :: nleaddim       ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: size_allowed   ! allowable size of the array
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    nleaddim = size(data,1)
    size_allowed = size( data , 2 )
    errc         = 0

    senddim  = sr%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr8_matrix_enda_xfer failed"
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr8_matrix_enda_xfer failed"
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    if(check_xfer) then

      rindex_check : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
        inode = sr%recvindex(inde)
        if((inode <= 0) .or. (inode > size_allowed)) then
          write(*,*) ' problem in rank 2 xfer...size_allowed=',size_allowed
          write(*,*) ' rindex : loop assignment operation...id,inode=',        &
                     lmpi_id,inode
          write(*,*) ' lmpi_xfer(cmpxr8_matrix_enda_xfer)failed'
          if(present(site)) write(*,*) ' ......Instance = ',site
          errc = 1
          exit rindex_check
        endif
      enddo rindex_check

      call lmpi_max(errc,errcm)
      call lmpi_bcast(errcm)
      if (errcm > 0) call lmpi_die

    endif

    rindex : do inde = 1, sr%recvproc(lmpi_nproc+1) - 1
      inode = sr%recvindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr%cmpxr8_mat_recvdata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) data, site, sr%size_sendindex
#endif

  end subroutine cmpxr8_matrix_enda_xfer


!tempStartExpand(lmpi_xferedge)
!=============================== integr_vector_xferedge
!
! non-blocking send/receive pair for rank 1 integr data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine integr_vector_xferedge(data, ghostlevel_arg, site )

    integer(system_i4),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine integr_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== integ8_vector_xferedge
!
! non-blocking send/receive pair for rank 1 integ8 data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine integ8_vector_xferedge(data, ghostlevel_arg, site )

    integer(system_i8),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine integ8_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== integ1_vector_xferedge
!
! non-blocking send/receive pair for rank 1 integ1 data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine integ1_vector_xferedge(data, ghostlevel_arg, site )

    integer(system_i1),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine integ1_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== logicl_vector_xferedge
!
! non-blocking send/receive pair for rank 1 logicl data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine logicl_vector_xferedge(data, ghostlevel_arg, site )

    logical,         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine logicl_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== single_vector_xferedge
!
! non-blocking send/receive pair for rank 1 single data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine single_vector_xferedge(data, ghostlevel_arg, site )

    real(system_r4),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine single_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== double_vector_xferedge
!
! non-blocking send/receive pair for rank 1 double data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine double_vector_xferedge(data, ghostlevel_arg, site )

    real(system_r8),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine double_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== cmpxr4_vector_xferedge
!
! non-blocking send/receive pair for rank 1 cmpxr4 data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine cmpxr4_vector_xferedge(data, ghostlevel_arg, site )

    complex(system_r4),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine cmpxr4_vector_xferedge
!tempStartExpand(lmpi_xferedge)
!=============================== cmpxr8_vector_xferedge
!
! non-blocking send/receive pair for rank 1 cmpxr8 data on edges
! (private)
!
! used to share a local array with all the other edges to fill partition
! boundary ghost edges.
!
!=============================================================================80

  subroutine cmpxr8_vector_xferedge(data, ghostlevel_arg, site )

    complex(system_r8),         dimension(:), intent(inout) :: data
    integer,          optional,     intent(in)    :: ghostlevel_arg
    character(len=*), optional,     intent(in)    :: site

#ifdef HAVE_MPI
    integer :: lvl                 ! mpi ghost node level
#endif

    continue

#ifdef HAVE_MPI
   if (lmpi_nproc == 1) return ! for sequential_mode and mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = edgeghostlevel
    endif

    if(present(site)) then
      call lmpi_xfer( data, ghostlevel_arg=lvl, site=site )
    else
      call lmpi_xfer( data, ghostlevel_arg=lvl )
    endif
#else
! avoid compiler warnings
    if (.false.) write(*,*) edgeghostlevel, ghostlevel_arg, data, site
#endif

  end subroutine cmpxr8_vector_xferedge

!tempStartExpand(lmpi_xfer_jacobian)
!========================== integr_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine integr_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    integer(system_i4), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    integer(system_i4), dimension(:,:,:,:), allocatable :: send_jac_entries
    integer(system_i4), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine integr_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== integ8_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine integ8_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    integer(system_i8), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    integer(system_i8), dimension(:,:,:,:), allocatable :: send_jac_entries
    integer(system_i8), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine integ8_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== integ1_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine integ1_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    integer(system_i1), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    integer(system_i1), dimension(:,:,:,:), allocatable :: send_jac_entries
    integer(system_i1), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine integ1_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== logicl_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine logicl_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    logical, dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    logical, dimension(:,:,:,:), allocatable :: send_jac_entries
    logical, dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine logicl_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== single_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine single_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    real(system_r4), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    real(system_r4), dimension(:,:,:,:), allocatable :: send_jac_entries
    real(system_r4), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine single_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== double_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine double_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    real(system_r8), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    real(system_r8), dimension(:,:,:,:), allocatable :: send_jac_entries
    real(system_r8), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine double_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== cmpxr4_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine cmpxr4_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    complex(system_r4), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    complex(system_r4), dimension(:,:,:,:), allocatable :: send_jac_entries
    complex(system_r4), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine cmpxr4_xfer_jacobian
!tempStartExpand(lmpi_xfer_jacobian)
!========================== cmpxr8_XFER_JACOBIAN ===========================80
!
!  Routine to transfer equation rows in a_off across processors.
!  This is so that we only have to form terms on level-0 nodes, then
!  this will transfer the ghosts
!
!=============================================================================80
  subroutine cmpxr8_xfer_jacobian(bs, iam, jam, g2m, m2g, a_off,               &
                                    nnodes0, nnodes01, l2g,                    &
                                    nsorted, sortedglobal, sortedlocal)

    use lmpi,        only : lmpi_conditional_stop
    use sort,        only : binary_search
    use kinddefs,    only : i8

    integer,                     intent(in)    :: bs     ! block size
    integer, dimension(:),       intent(in)    :: iam, jam, g2m, m2g
    complex(system_r8), dimension(:,:,:),  intent(inout) :: a_off
    integer,                     intent(in)    :: nnodes0, nnodes01
    integer(i8), dimension(nnodes01),intent(in):: l2g
    integer,                     intent(in)    :: nsorted
    integer(i8), dimension(nsorted), intent(in):: sortedglobal
    integer, dimension(nsorted), intent(in)    :: sortedlocal

    integer, parameter :: ghost_level     = 1

    integer :: n_rows_to_send, n_rows_to_recv, jstart, jend, column_num
    integer :: proc_max_columns, packed_index, row, max_columns, entry_index
    integer :: j, global_col, local_col, row_column_count, col
    integer :: column_found_status

    integer, dimension(:,:), pointer :: send_jac_column, recv_jac_column

    complex(system_r8), dimension(:,:,:,:), allocatable :: send_jac_entries
    complex(system_r8), dimension(:,:,:,:), allocatable :: recv_jac_entries

  continue

! This routine breaks down for one processor so just return in
! this case.  Obviously we wouldn't need to exchange rows anyways

    if ( lmpi_nproc == 1 ) return

! Number of Jacobian rows to send and receive

    n_rows_to_send= sr(ghost_level)%sendproc(lmpi_nproc+1) - 1
    n_rows_to_recv= sr(ghost_level)%recvproc(lmpi_nproc+1) - 1

! Determine the max number of columns in any of the rows that we are sending out

    proc_max_columns = 0
    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      jstart = iam(row)
      jend   = iam(row+1)-1
      row_column_count = jend-jstart+1
      proc_max_columns = max(proc_max_columns, row_column_count)
    end do

! Figure out the global max number of columns to be sent out

    call lmpi_max(proc_max_columns, max_columns)
    call lmpi_bcast(max_columns)

    allocate(send_jac_column(max_columns,n_rows_to_send))
    allocate(recv_jac_column(max_columns,n_rows_to_recv))
    allocate(send_jac_entries(bs,bs,max_columns,n_rows_to_send))
    allocate(recv_jac_entries(bs,bs,max_columns,n_rows_to_recv))

    send_jac_column = 0                      ! to mark entries as unused
    recv_jac_column = 0                      ! to mark entries as unused

! Pack the data

    do packed_index = 1, n_rows_to_send
      row = g2m(sr(ghost_level)%sendindex(packed_index))
      entry_index = 0
      do j = iam(row), iam(row+1)-1
        entry_index = entry_index + 1
        col = m2g(jam(j))
        send_jac_column(entry_index,packed_index) = l2g(col)
        send_jac_entries(:,:,entry_index,packed_index) = a_off(:,:,j)
      end do
    end do

! Send the data

    call lmpi_sendreceive(send_jac_column,                                     &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_column,                                     &
                          sr(ghost_level)%recvproc )

    call lmpi_sendreceive(send_jac_entries,                                    &
                          sr(ghost_level)%sendproc,                            &
                          recv_jac_entries,                                    &
                          sr(ghost_level)%recvproc )

! Loop over ghost rows and see if we need to unpack and store each received row

    column_found_status = 0
    for_each_packed_row : do packed_index = 1, n_rows_to_recv

      row = g2m(sr(ghost_level)%recvindex(packed_index))

      unpack_row : do entry_index = 1, max_columns
        global_col = recv_jac_column(entry_index,packed_index)
        if ( global_col < 1 ) exit unpack_row        ! reached end of row
        local_col = binary_search(nsorted,sortedglobal,global_col)
        if (local_col > 0) then
          local_col = sortedlocal(local_col)
        else
          local_col = 0
        end if

! local_node = 0 if past level 1
! also kick out if greater than level 1

        if (local_col < 1 .or. local_col > nnodes0) cycle unpack_row

! use search over ja to compute j from the local_node (aka the column)

        jstart = iam(row)
        jend   = iam(row+1)-1
        hunt_for_col : do j = jstart, jend
          column_num = m2g(jam(j))
          if ( column_num == local_col ) exit hunt_for_col
        end do hunt_for_col

        if ( j > jend ) then
          write(*,*) 'xfer_jacobian: Bug in finding column'
          column_found_status = 1
          exit for_each_packed_row
        endif

        a_off(:,:,j) = recv_jac_entries(:,:,entry_index,packed_index)

      end do unpack_row
    end do for_each_packed_row
    call lmpi_conditional_stop(column_found_status)

! Deallocate some memory we don't need anymore

    deallocate(send_jac_column,recv_jac_column)
    deallocate(send_jac_entries,recv_jac_entries)

  end subroutine cmpxr8_xfer_jacobian

!tempStartExpand(lmpi_sumnode)
!=============================== integr_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 integr
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integr_vector_sumnode(data, ghostlevel_arg )

    integer(system_i4),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integr_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%integr_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%integr_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_senddata(senddim)) failed"

      sr(lvl)%integr_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%integr_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_integer,                                            &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integr_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%integr_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%integr_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_integer,                                            &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integr_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integr_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integr_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%integr_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integr_vector_sumnode

!=============================== integr_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 integr
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integr_matrix_sumnode(data, ghostlevel_arg )

    integer(system_i4),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integr_mat_allocated ) then
      nallocdim = size(sr(lvl)%integr_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%integr_mat_recvdata)
        deallocate(sr(lvl)%integr_mat_senddata)

        allocate(sr(lvl)%integr_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integr_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%integr_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integr_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%integr_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%integr_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%integr_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%integr_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_integer,                                  &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integr_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%integr_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%integr_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_integer,                                  &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integr_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integr_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integr_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%integr_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integr_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== integ8_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 integ8
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integ8_vector_sumnode(data, ghostlevel_arg )

    integer(system_i8),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integ8_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%integ8_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%integ8_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_senddata(senddim)) failed"

      sr(lvl)%integ8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%integ8_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_integer8,                                           &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integ8_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%integ8_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%integ8_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_integer8,                                           &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integ8_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ8_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ8_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%integ8_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integ8_vector_sumnode

!=============================== integ8_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 integ8
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integ8_matrix_sumnode(data, ghostlevel_arg )

    integer(system_i8),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integ8_mat_allocated ) then
      nallocdim = size(sr(lvl)%integ8_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%integ8_mat_recvdata)
        deallocate(sr(lvl)%integ8_mat_senddata)

        allocate(sr(lvl)%integ8_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integ8_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%integ8_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integ8_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%integ8_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%integ8_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%integ8_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%integ8_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_integer8,                                 &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integ8_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%integ8_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%integ8_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_integer8,                                 &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integ8_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ8_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ8_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%integ8_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integ8_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== integ1_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 integ1
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integ1_vector_sumnode(data, ghostlevel_arg )

    integer(system_i1),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integ1_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%integ1_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%integ1_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_senddata(senddim)) failed"

      sr(lvl)%integ1_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%integ1_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_byte,                                               &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integ1_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%integ1_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%integ1_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_byte,                                               &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integ1_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ1_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ1_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%integ1_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integ1_vector_sumnode

!=============================== integ1_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 integ1
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integ1_matrix_sumnode(data, ghostlevel_arg )

    integer(system_i1),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integ1_mat_allocated ) then
      nallocdim = size(sr(lvl)%integ1_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%integ1_mat_recvdata)
        deallocate(sr(lvl)%integ1_mat_senddata)

        allocate(sr(lvl)%integ1_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(integ1_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%integ1_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re integ1_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%integ1_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%integ1_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%integ1_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%integ1_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_byte,                                     &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integ1_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%integ1_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%integ1_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_byte,                                     &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integ1_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ1_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ1_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%integ1_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integ1_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== logicl_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 logicl
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine logicl_vector_sumnode(data, ghostlevel_arg )

    logical,        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%logicl_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%logicl_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%logicl_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_senddata(senddim)) failed"

      sr(lvl)%logicl_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%logicl_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_logical,                                            &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in logicl_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%logicl_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%logicl_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_logical,                                            &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in logicl_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send logicl_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv logicl_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%logicl_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine logicl_vector_sumnode

!=============================== logicl_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 logicl
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine logicl_matrix_sumnode(data, ghostlevel_arg )

    logical,        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%logicl_mat_allocated ) then
      nallocdim = size(sr(lvl)%logicl_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%logicl_mat_recvdata)
        deallocate(sr(lvl)%logicl_mat_senddata)

        allocate(sr(lvl)%logicl_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(logicl_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%logicl_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re logicl_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%logicl_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%logicl_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%logicl_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%logicl_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_logical,                                  &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in logicl_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%logicl_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%logicl_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_logical,                                  &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in logicl_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send logicl_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv logicl_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%logicl_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine logicl_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== single_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 single
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine single_vector_sumnode(data, ghostlevel_arg )

    real(system_r4),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%single_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%single_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%single_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_senddata(senddim)) failed"

      sr(lvl)%single_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%single_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_real,                                               &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in single_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%single_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%single_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_real,                                               &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in single_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send single_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv single_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%single_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine single_vector_sumnode

!=============================== single_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 single
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine single_matrix_sumnode(data, ghostlevel_arg )

    real(system_r4),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%single_mat_allocated ) then
      nallocdim = size(sr(lvl)%single_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%single_mat_recvdata)
        deallocate(sr(lvl)%single_mat_senddata)

        allocate(sr(lvl)%single_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(single_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%single_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re single_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%single_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%single_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%single_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%single_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_real,                                     &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in single_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%single_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%single_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_real,                                     &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in single_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send single_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv single_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%single_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine single_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== double_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 double
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine double_vector_sumnode(data, ghostlevel_arg )

    real(system_r8),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%double_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%double_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%double_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_senddata(senddim)) failed"

      sr(lvl)%double_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%double_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_double_precision,                                   &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in double_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%double_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%double_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_double_precision,                                   &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in double_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send double_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv double_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%double_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine double_vector_sumnode

!=============================== double_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 double
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine double_matrix_sumnode(data, ghostlevel_arg )

    real(system_r8),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%double_mat_allocated ) then
      nallocdim = size(sr(lvl)%double_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%double_mat_recvdata)
        deallocate(sr(lvl)%double_mat_senddata)

        allocate(sr(lvl)%double_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(double_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%double_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re double_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%double_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%double_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%double_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%double_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_double_precision,                         &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in double_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%double_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%double_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_double_precision,                         &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in double_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send double_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv double_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%double_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine double_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== cmpxr4_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 cmpxr4
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine cmpxr4_vector_sumnode(data, ghostlevel_arg )

    complex(system_r4),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%cmpxr4_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%cmpxr4_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%cmpxr4_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_senddata(senddim)) failed"

      sr(lvl)%cmpxr4_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%cmpxr4_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_complex,                                            &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in cmpxr4_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%cmpxr4_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%cmpxr4_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_complex,                                            &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in cmpxr4_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr4_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr4_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%cmpxr4_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine cmpxr4_vector_sumnode

!=============================== cmpxr4_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 cmpxr4
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine cmpxr4_matrix_sumnode(data, ghostlevel_arg )

    complex(system_r4),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%cmpxr4_mat_allocated ) then
      nallocdim = size(sr(lvl)%cmpxr4_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%cmpxr4_mat_recvdata)
        deallocate(sr(lvl)%cmpxr4_mat_senddata)

        allocate(sr(lvl)%cmpxr4_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(cmpxr4_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%cmpxr4_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re cmpxr4_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%cmpxr4_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%cmpxr4_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%cmpxr4_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%cmpxr4_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_complex,                                  &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in cmpxr4_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%cmpxr4_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%cmpxr4_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_complex,                                  &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in cmpxr4_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr4_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr4_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%cmpxr4_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine cmpxr4_matrix_sumnode

!tempStartExpand(lmpi_sumnode)
!=============================== cmpxr8_vector_sumnode
!
! non-blocking send/receive pair for summing rank 1 cmpxr8
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine cmpxr8_vector_sumnode(data, ghostlevel_arg )

    complex(system_r8),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%cmpxr8_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%cmpxr8_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%cmpxr8_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_senddata(senddim)) failed"

      sr(lvl)%cmpxr8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(5)'
          call mpi_irecv( sr(lvl)%cmpxr8_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_double_complex,                                     &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in cmpxr8_vector_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%cmpxr8_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(5)'
          call mpi_isend( sr(lvl)%cmpxr8_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_double_complex,                                     &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in cmpxr8_vector_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr8_vector_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr8_vector_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = data(inode) + sr(lvl)%cmpxr8_vec_senddata(inde)
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine cmpxr8_vector_sumnode

!=============================== cmpxr8_matrix_sumnode
!
! non-blocking send/receive pair for summing rank 2 cmpxr8
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine cmpxr8_matrix_sumnode(data, ghostlevel_arg )

    complex(system_r8),        dimension(:,:), intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: nleaddim       ! extent of leading dimension
    integer :: nallocdim      ! extent of leading dimension
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode,l        ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    nleaddim = size(data,1)
    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%cmpxr8_mat_allocated ) then
      nallocdim = size(sr(lvl)%cmpxr8_mat_recvdata,1)
      leader : if ( nallocdim < nleaddim) then

        deallocate(sr(lvl)%cmpxr8_mat_recvdata)
        deallocate(sr(lvl)%cmpxr8_mat_senddata)

        allocate(sr(lvl)%cmpxr8_mat_recvdata(max(1,nleaddim),                  &
                 max(1,recvdim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re allocate(cmpxr8_mat_recvdata(nleaddim,recvdim)) failed"

        allocate(sr(lvl)%cmpxr8_mat_senddata(max(1,nleaddim),                  &
                 max(1,senddim)), stat = astat)

        if(astat /= 0) print *,                                                &
          "lmpi: re cmpxr8_mat_senddata(nleaddim,senddim)) failed"

        nallocdim = nleaddim

      endif leader

    else chk_alloc

      nallocdim = nleaddim

      allocate(sr(lvl)%cmpxr8_mat_recvdata(max(1,nleaddim),                    &
               max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_mat_recvdata(nleaddim,recvdim)) failed"

      allocate(sr(lvl)%cmpxr8_mat_senddata(max(1,nleaddim),                    &
               max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_mat_senddata(nleaddim,senddim)) failed"

      sr(lvl)%cmpxr8_mat_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(6)'
          call mpi_irecv( sr(lvl)%cmpxr8_mat_senddata(                         &
               1, sr(lvl)%sendproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_double_complex,                           &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in cmpxr8_matrix_sumnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      slead : do l = 1, nleaddim
        sr(lvl)%cmpxr8_mat_recvdata(l,inde) = data(l,inode)
      enddo slead
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(6)'
          call mpi_isend( sr(lvl)%cmpxr8_mat_recvdata(                         &
               1, sr(lvl)%recvproc(i_other_proc+1) ),                          &
               length*nallocdim, mpi_double_complex,                           &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in cmpxr8_matrix_sumnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr8_matrix_sumnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr8_matrix_sumnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      rlead : do l = 1, nleaddim
        data(l,inode) = data(l,inode) + sr(lvl)%cmpxr8_mat_senddata(l,inde)
      enddo rlead
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine cmpxr8_matrix_sumnode

!tempStartExpand(lmpi_maxnode)
!=============================== integr_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 integr
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integr_vector_maxnode(data, ghostlevel_arg )

    integer(system_i4),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integr_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%integr_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%integr_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integr_vec_senddata(senddim)) failed"

      sr(lvl)%integr_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%integr_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_integer,                                            &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integr_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%integr_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%integr_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_integer,                                            &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integr_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integr_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integr_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%integr_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integr_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== integ8_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 integ8
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integ8_vector_maxnode(data, ghostlevel_arg )

    integer(system_i8),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integ8_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%integ8_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%integ8_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ8_vec_senddata(senddim)) failed"

      sr(lvl)%integ8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%integ8_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_integer8,                                           &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integ8_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%integ8_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%integ8_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_integer8,                                           &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integ8_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ8_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ8_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%integ8_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integ8_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== integ1_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 integ1
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine integ1_vector_maxnode(data, ghostlevel_arg )

    integer(system_i1),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%integ1_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%integ1_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%integ1_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(integ1_vec_senddata(senddim)) failed"

      sr(lvl)%integ1_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%integ1_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_byte,                                               &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in integ1_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%integ1_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%integ1_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_byte,                                               &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in integ1_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send integ1_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv integ1_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%integ1_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine integ1_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== logicl_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 logicl
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine logicl_vector_maxnode(data, ghostlevel_arg )

    logical,        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%logicl_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%logicl_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%logicl_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(logicl_vec_senddata(senddim)) failed"

      sr(lvl)%logicl_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%logicl_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_logical,                                            &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in logicl_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%logicl_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%logicl_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_logical,                                            &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in logicl_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send logicl_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv logicl_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%logicl_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine logicl_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== single_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 single
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine single_vector_maxnode(data, ghostlevel_arg )

    real(system_r4),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%single_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%single_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%single_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(single_vec_senddata(senddim)) failed"

      sr(lvl)%single_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%single_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_real,                                               &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in single_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%single_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%single_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_real,                                               &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in single_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send single_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv single_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%single_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine single_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== double_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 double
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine double_vector_maxnode(data, ghostlevel_arg )

    real(system_r8),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%double_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%double_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%double_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(double_vec_senddata(senddim)) failed"

      sr(lvl)%double_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%double_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_double_precision,                                   &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in double_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%double_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%double_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_double_precision,                                   &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in double_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send double_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv double_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%double_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine double_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== cmpxr4_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 cmpxr4
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine cmpxr4_vector_maxnode(data, ghostlevel_arg )

    complex(system_r4),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%cmpxr4_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%cmpxr4_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%cmpxr4_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr4_vec_senddata(senddim)) failed"

      sr(lvl)%cmpxr4_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%cmpxr4_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_complex,                                            &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in cmpxr4_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%cmpxr4_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%cmpxr4_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_complex,                                            &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in cmpxr4_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr4_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr4_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%cmpxr4_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine cmpxr4_vector_maxnode

!tempStartExpand(lmpi_maxnode)
!=============================== cmpxr8_vector_maxnode
!
! non-blocking send/receive pair for maxing rank 1 cmpxr8
!   ghost node data on the level 0 nodes  (private)

!=============================================================================80

  subroutine cmpxr8_vector_maxnode(data, ghostlevel_arg )

    complex(system_r8),        dimension(:),   intent(inout) :: data
    integer,         optional,       intent(in)    :: ghostlevel_arg

#ifdef HAVE_MPI
    integer :: ierr           ! communicator, error flag
    integer :: mpitag, length ! unique message tag and length
    integer :: recvdim        ! extents of mpi work array
    integer :: senddim        ! extents of mpi work array
    integer :: inde           ! mpi packing loop indexes
    integer :: inode          ! mpi packing loop indexes
    integer :: i_other_proc   ! processor loop index
    integer :: astat          ! allocate status
    integer :: lvl            ! mpi ghost level to transfer
#endif

    continue

#ifdef HAVE_MPI
    if (lmpi_nproc == 1) return ! mpi with one proc

    if( present(ghostlevel_arg) )then
      lvl = ghostlevel_arg
    else
      lvl = defaultghostlevel
    endif

    senddim  = sr(lvl)%sendproc(lmpi_nproc+1) - 1
    recvdim  = sr(lvl)%recvproc(lmpi_nproc+1) - 1

! check if mpi work array is allocated and the correct size
    chk_alloc : if ( sr(lvl)%cmpxr8_vec_allocated ) then

    else chk_alloc

      allocate(sr(lvl)%cmpxr8_vec_recvdata(max(1,recvdim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_recvdata(recvdim)) failed"

      allocate(sr(lvl)%cmpxr8_vec_senddata(max(1,senddim)), stat = astat)

      if(astat /= 0) print *,                                                  &
        "lmpi: allocate(cmpxr8_vec_senddata(senddim)) failed"

      sr(lvl)%cmpxr8_vec_allocated = .TRUE.

    endif chk_alloc

! post all the mpi recv commands first.

    nrecv = 0

    recv_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_r : if (i_other_proc == lmpi_id) then
! duh... i already have it
        else

        length = sr(lvl)%sendproc(i_other_proc+2)                              &
               - sr(lvl)%sendproc(i_other_proc+1)

        rlen : if (length>0) then

          nrecv  = nrecv + 1
          mpitag = 0 ! mpitag = lmpi_id * lmpi_nproc + i_other_proc

!         write(*,*)'irecv(7)'
          call mpi_irecv( sr(lvl)%cmpxr8_vec_senddata(                         &
               sr(lvl)%sendproc(i_other_proc+1) ),                             &
               length, mpi_double_complex,                                     &
               i_other_proc, mpitag, lmpi_comm , recvreq(nrecv), ierr )

          irecv_error: if( ierr /= lmpi_success )then
            print *, "mpi_irecv in cmpxr8_vector_maxnode failed... "
          endif irecv_error

        endif rlen
      endif if_me_r
    enddo recv_loop

! copy node information to send arrays

    sindex : do inde = 1, sr(lvl)%recvproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%recvindex(inde)
      sr(lvl)%cmpxr8_vec_recvdata(inde) = data(inode)
    enddo sindex

! post all the mpi send commands second
! (note that the send mpitag is the inverse of the recv command).

    nsend=0

    send_loop : do i_other_proc = 0, lmpi_nproc-1

      if_me_s : if (i_other_proc == lmpi_id) then
! duh... why send it to myself ?
      else

        length = sr(lvl)%recvproc(i_other_proc+2)                              &
               - sr(lvl)%recvproc(i_other_proc+1)

        slen : if (length>0) then

          nsend  = nsend + 1
          mpitag = 0 ! mpitag = i_other_proc * lmpi_nproc + lmpi_id

!         write(*,*)'isend(7)'
          call mpi_isend( sr(lvl)%cmpxr8_vec_recvdata(                         &
               sr(lvl)%recvproc(i_other_proc+1) ),                             &
               length, mpi_double_complex,                                     &
               i_other_proc, mpitag, lmpi_comm, sendreq(nsend), ierr )

          isend_error: if( ierr /= lmpi_success )then
            print *, "mpi_isend in cmpxr8_vector_maxnode failed... "
          endif isend_error

        endif slen
      endif if_me_s
    enddo send_loop

! wait for all mpi comnunication to complete

    ierr = lmpi_success
    if (nsend>0) call lmpi_waitall(nsend, sendreq, ierr)

    wait_send_error: if( ierr /= lmpi_success )then
      print *, "send mpi_wait in send cmpxr8_vector_maxnode failed..."
      return
    endif wait_send_error

    ierr = lmpi_success
    if (nrecv>0) call lmpi_waitall(nrecv, recvreq, ierr)

    wait_recv_error: if( ierr /= lmpi_success )then
      print *, "recv mpi_wait in recv cmpxr8_vector_maxnode failed..."
      return
    endif wait_recv_error

! copy recv'd node information to local arrays

    rindex : do inde = 1, sr(lvl)%sendproc(lmpi_nproc+1) - 1
      inode = sr(lvl)%sendindex(inde)
      data(inode) = max(data(inode),sr(lvl)%cmpxr8_vec_senddata(inde))
    enddo rindex

#else
! avoid compiler warnings
    if (.false.) write(*,*) ghostlevel_arg, data
#endif

  end subroutine cmpxr8_vector_maxnode



!tempStartExpand(lmpi_sendreceive)
!=============================== integr_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 integr data
! (private)
!
!=============================================================================80

  subroutine integr_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i4),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i4),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_integer, sendId-1, mpitag,                                       &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_integer, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine integr_vector_sendreceive

!=============================== integr_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 integr data
! (private)
!
!=============================================================================80

  subroutine integr_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i4),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i4),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_integer, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_integer, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integr_matrix_sendreceive

!=============================== integr_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 integr data
! (private)
!
!=============================================================================80

  subroutine integr_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i4),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i4),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_integer, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_integer, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integr_matrx3_sendreceive

!=============================== integr_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 integr data
! (private)
!
!=============================================================================80

  subroutine integr_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i4),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i4),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_integer, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_integer, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integr_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== integ8_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 integ8 data
! (private)
!
!=============================================================================80

  subroutine integ8_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i8),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i8),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_integer8, sendId-1, mpitag,                                      &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_integer8, recvId-1, mpitag,                                      &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ8_vector_sendreceive

!=============================== integ8_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 integ8 data
! (private)
!
!=============================================================================80

  subroutine integ8_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i8),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i8),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_integer8, sendId-1, mpitag,                                   &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_integer8, recvId-1, mpitag,                                      &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ8_matrix_sendreceive

!=============================== integ8_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 integ8 data
! (private)
!
!=============================================================================80

  subroutine integ8_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i8),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i8),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_integer8, sendId-1, mpitag,                                   &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_integer8, recvId-1, mpitag,                                      &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ8_matrx3_sendreceive

!=============================== integ8_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 integ8 data
! (private)
!
!=============================================================================80

  subroutine integ8_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i8),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i8),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_integer8, sendId-1, mpitag,                                   &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_integer8, recvId-1, mpitag,                                      &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ8_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== integ1_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 integ1 data
! (private)
!
!=============================================================================80

  subroutine integ1_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i1),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i1),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_byte, sendId-1, mpitag,                                          &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_byte, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ1_vector_sendreceive

!=============================== integ1_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 integ1 data
! (private)
!
!=============================================================================80

  subroutine integ1_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i1),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i1),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_byte, sendId-1, mpitag,                                       &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_byte, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ1_matrix_sendreceive

!=============================== integ1_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 integ1 data
! (private)
!
!=============================================================================80

  subroutine integ1_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i1),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i1),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_byte, sendId-1, mpitag,                                       &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_byte, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ1_matrx3_sendreceive

!=============================== integ1_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 integ1 data
! (private)
!
!=============================================================================80

  subroutine integ1_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    integer(system_i1),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    integer(system_i1),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_byte, sendId-1, mpitag,                                       &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_byte, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine integ1_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== logicl_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 logicl data
! (private)
!
!=============================================================================80

  subroutine logicl_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    logical,        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    logical,        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_logical, sendId-1, mpitag,                                       &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_logical, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine logicl_vector_sendreceive

!=============================== logicl_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 logicl data
! (private)
!
!=============================================================================80

  subroutine logicl_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    logical,        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    logical,        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_logical, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_logical, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine logicl_matrix_sendreceive

!=============================== logicl_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 logicl data
! (private)
!
!=============================================================================80

  subroutine logicl_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    logical,        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    logical,        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_logical, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_logical, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine logicl_matrx3_sendreceive

!=============================== logicl_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 logicl data
! (private)
!
!=============================================================================80

  subroutine logicl_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    logical,        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    logical,        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_logical, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_logical, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine logicl_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== single_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 single data
! (private)
!
!=============================================================================80

  subroutine single_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r4),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r4),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_real, sendId-1, mpitag,                                          &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_real, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine single_vector_sendreceive

!=============================== single_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 single data
! (private)
!
!=============================================================================80

  subroutine single_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r4),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r4),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_real, sendId-1, mpitag,                                       &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_real, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine single_matrix_sendreceive

!=============================== single_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 single data
! (private)
!
!=============================================================================80

  subroutine single_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r4),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r4),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_real, sendId-1, mpitag,                                       &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_real, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine single_matrx3_sendreceive

!=============================== single_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 single data
! (private)
!
!=============================================================================80

  subroutine single_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r4),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r4),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_real, sendId-1, mpitag,                                       &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_real, recvId-1, mpitag,                                          &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine single_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== double_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 double data
! (private)
!
!=============================================================================80

  subroutine double_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r8),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r8),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_double_precision, sendId-1, mpitag,                              &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_double_precision, recvId-1, mpitag,                              &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine double_vector_sendreceive

!=============================== double_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 double data
! (private)
!
!=============================================================================80

  subroutine double_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r8),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r8),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_double_precision, sendId-1, mpitag,                           &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_double_precision, recvId-1, mpitag,                              &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine double_matrix_sendreceive

!=============================== double_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 double data
! (private)
!
!=============================================================================80

  subroutine double_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r8),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r8),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_double_precision, sendId-1, mpitag,                           &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_double_precision, recvId-1, mpitag,                              &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine double_matrx3_sendreceive

!=============================== double_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 double data
! (private)
!
!=============================================================================80

  subroutine double_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    real(system_r8),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    real(system_r8),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_double_precision, sendId-1, mpitag,                           &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_double_precision, recvId-1, mpitag,                              &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine double_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== cmpxr4_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 cmpxr4 data
! (private)
!
!=============================================================================80

  subroutine cmpxr4_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r4),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r4),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_complex, sendId-1, mpitag,                                       &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_complex, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr4_vector_sendreceive

!=============================== cmpxr4_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 cmpxr4 data
! (private)
!
!=============================================================================80

  subroutine cmpxr4_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r4),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r4),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_complex, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_complex, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr4_matrix_sendreceive

!=============================== cmpxr4_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 cmpxr4 data
! (private)
!
!=============================================================================80

  subroutine cmpxr4_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r4),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r4),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_complex, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_complex, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr4_matrx3_sendreceive

!=============================== cmpxr4_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 cmpxr4 data
! (private)
!
!=============================================================================80

  subroutine cmpxr4_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r4),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r4),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_complex, sendId-1, mpitag,                                    &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_complex, recvId-1, mpitag,                                       &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr4_matrx4_sendreceive

!tempStartExpand(lmpi_sendreceive)
!=============================== cmpxr8_vector_sendreceive
!
! non-blocking send/receive pair for rank 1 cmpxr8 data
! (private)
!
!=============================================================================80

  subroutine cmpxr8_vector_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r8),        dimension(:),            intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r8),        dimension(:),            intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(8)'
        call mpi_irecv(                                                        &
          recvdata(recvindex(sendId)),                                         &
          messagelength,                                                       &
          mpi_double_complex, sendId-1, mpitag,                                &
          lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(8)'
        call mpi_isend(                                                        &
          senddata(sendindex(recvId)),                                         &
          messagelength,                                                       &
          mpi_double_complex, recvId-1, mpitag,                                &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(recvindex(1):recvindex(2)-1)=senddata(sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr8_vector_sendreceive

!=============================== cmpxr8_matrix_sendreceive
!
! non-blocking send/receive pair for rank 2 cmpxr8 data
! (private)
!
!=============================================================================80

  subroutine cmpxr8_matrix_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r8),        dimension(:,:),          intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r8),        dimension(:,:),          intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: nleaddim       ! extent of leading dimension
    integer :: received, sent ! number of send and recv messages
    integer :: recvId, sendId ! processorId+1 of send and recv
    integer :: messagelength  ! duh...
    integer :: mpitag         ! unique message tag
    integer :: ierror         ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    nleaddim = size(senddata,1)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,recvindex(sendId)),                                    &
             messagelength*nleaddim,                                           &
             mpi_double_complex, sendId-1, mpitag,                             &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,sendindex(recvId)),                                       &
          messagelength*nleaddim,                                              &
          mpi_double_complex, recvId-1, mpitag,                                &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,recvindex(1):recvindex(2)-1) =                                  &
    senddata(:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr8_matrix_sendreceive

!=============================== cmpxr8_matrx3_sendreceive
!
! non-blocking send/receive pair for rank 3 cmpxr8 data
! (private)
!
!=============================================================================80

  subroutine cmpxr8_matrx3_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r8),        dimension(:,:,:),        intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r8),        dimension(:,:,:),        intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent     ! number of send and recv messages
    integer :: recvId, sendId     ! processorId+1 of send and recv
    integer :: messagelength      ! duh...
    integer :: mpitag             ! unique message tag
    integer :: ierror             ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    mleaddim = size(senddata,1)
    nleaddim = size(senddata,2)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,recvindex(sendId)),                                  &
             messagelength*mleaddim*nleaddim,                                  &
             mpi_double_complex, sendId-1, mpitag,                             &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,sendindex(recvId)),                                     &
          messagelength*mleaddim*nleaddim,                                     &
          mpi_double_complex, recvId-1, mpitag,                                &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,recvindex(1):recvindex(2)-1) =                                &
    senddata(:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr8_matrx3_sendreceive

!=============================== cmpxr8_matrx4_sendreceive
!
! non-blocking send/receive pair for rank 4 cmpxr8 data
! (private)
!
!=============================================================================80

  subroutine cmpxr8_matrx4_sendreceive(senddata, sendindex,                    &
                                         recvdata, recvindex )

    complex(system_r8),        dimension(:,:,:,:),      intent(in)  :: senddata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: sendindex
    complex(system_r8),        dimension(:,:,:,:),      intent(out) :: recvdata
    integer,         dimension(lmpi_nproc+1), intent(in)  :: recvindex

#ifdef HAVE_MPI
    integer :: lleaddim, mleaddim, nleaddim ! extent of leading dimensions
    integer :: received, sent               ! number of send and recv messages
    integer :: recvId, sendId               ! processorId+1 of send and recv
    integer :: messagelength                ! duh...
    integer :: mpitag                       ! unique message tag
    integer :: ierror                       ! mpi error reporting
#endif

    continue

#ifdef HAVE_MPI

    lleaddim = size(senddata,1)
    mleaddim = size(senddata,2)
    nleaddim = size(senddata,3)

    received = 0
    recvId = lmpi_id + 1
    do sendId = 1, lmpi_nproc
      messagelength = recvindex(sendId+1) - recvindex(sendId)
      if (messagelength > 0) then
        received = received + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'irecv(9)'
        call mpi_irecv(                                                        &
             recvdata(1,1,1,recvindex(sendId)),                                &
             messagelength*lleaddim*mleaddim*nleaddim,                         &
             mpi_double_complex, sendId-1, mpitag,                             &
             lmpi_comm, recvreq(received), ierror)
      end if
    end do

    sent = 0
    sendId = lmpi_id + 1
    do recvId = 1, lmpi_nproc
      messagelength = sendindex(recvId+1) - sendindex(recvId)
      if (messagelength > 0) then
        sent = sent + 1
        mpitag = 0 ! mpitag = recvId * lmpi_nproc + sendId
!       write(*,*)'isend(9)'
        call mpi_isend(                                                        &
          senddata(1,1,1,sendindex(recvId)),                                   &
          messagelength*lleaddim*mleaddim*nleaddim,                            &
          mpi_double_complex, recvId-1, mpitag,                                &
          lmpi_comm, sendreq(sent), ierror)
      end if
    end do

    if (sent>0)     call lmpi_waitall(sent,     sendreq, ierror)
    if (received>0) call lmpi_waitall(received, recvreq, ierror)

#else
    recvdata(:,:,:,recvindex(1):recvindex(2)-1) =                              &
    senddata(:,:,:,sendindex(1):sendindex(2)-1)
#endif

  end subroutine cmpxr8_matrx4_sendreceive


!================================== LMPI_COPY ================================80
!
! Fills the the sendproc, recvproc, sendindex, and recvindex arrays
! from sr1.
!
! For cell-centered (cc), this is a work in progress.
!
!=============================================================================80

  subroutine lmpi_copy(sr1,sre)

#ifdef HAVE_MPI

    use lmpi,        only : lmpi_conditional_stop, lmpi_nproc
    use interp_defs, only : basic_sendrecv_type

    type (basic_sendrecv_type), dimension(:), intent(in) :: sr1, sre

    integer :: i,j,local_ndatalevel,p1, idata

  continue

    p1 = lmpi_id + 1

    local_ndatalevel = ndatalevel

    if ( .not. sr_allocated ) then
      allocate(sr(local_ndatalevel))
      sr_allocated = .TRUE.
      do i=1,local_ndatalevel
        call nullify_sendrecv(sr(i))
      end do
    end if

    if (lmpi_nproc > 1 ) then

       call lmpi_deallocate_sendrecv(1)

       sr(1)%sendrecv_allocated = .true.

       allocate(sr(1)%sendproc(lmpi_nproc+1))
       sr(1)%sendproc = sr1(p1)%sendproc

       allocate(sr(1)%recvproc(lmpi_nproc+1))
       sr(1)%recvproc = sr1(p1)%recvproc

       i = 1
       if (associated(sr1(p1)%sendindex)) i = size(sr1(p1)%sendindex)
       allocate(sr(1)%sendindex(i));   sr(1)%sendindex = 0
       if (associated(sr1(p1)%sendindex)) then
          sr(1)%sendindex = sr1(p1)%sendindex
          sr(1)%size_sendindex = i
       else
          sr(1)%size_sendindex = 0
       end if

       j = 1
       if (associated(sr1(p1)%recvindex)) j = size(sr1(p1)%recvindex)
       allocate(sr(1)%recvindex(j));   sr(1)%recvindex = 0
       if (associated(sr1(p1)%recvindex)) then
          sr(1)%recvindex = sr1(p1)%recvindex
          sr(1)%size_recvindex = j
       else
          sr(1)%size_recvindex = 0
       end if

! sr2
       call lmpi_deallocate_sendrecv(2)

       sr(2)%sendrecv_allocated = .true.
       allocate(sr(2)%sendproc(lmpi_nproc+1))
       sr(2)%sendproc = 1 ! sr2(p1)%sendproc sr2 DUMMY

       allocate(sr(2)%recvproc(lmpi_nproc+1))
       sr(2)%recvproc = 1 ! sr2(p1)%recvproc sr2 DUMMY

       i = 1
       ! if (associated(sr2(p1)%sendindex)) i = size(sr2(p1)%sendindex)
       allocate(sr(2)%sendindex(i));   sr(2)%sendindex=0
       !if (associated(sr2(p1)%sendindex)) then
       !  sr(2)%sendindex=sr2(p1)%sendindex
       !  sr(2)%size_sendindex = i
       !else
          sr(2)%size_sendindex = 0
       !end if

       j = 1
       !if (associated(sr2(p1)%recvindex)) j = size(sr2(p1)%recvindex)
       allocate(sr(2)%recvindex(j));   sr(2)%recvindex=0
       !if (associated(sr2(p1)%recvindex)) then
       !  sr(2)%recvindex=sr2(p1)%recvindex
       !  sr(2)%size_recvindex = j
       !else
          sr(2)%size_recvindex = 0
       !end if

! sre

       call lmpi_deallocate_sendrecv(3)

       sr(3)%sendrecv_allocated = .true.

       allocate(sr(3)%sendproc(lmpi_nproc+1))
       sr(3)%sendproc = sre(p1)%sendproc

       allocate(sr(3)%recvproc(lmpi_nproc+1))
       sr(3)%recvproc = sre(p1)%recvproc

       i = 1
       if (associated(sre(p1)%sendindex)) i = size(sre(p1)%sendindex)
       allocate(sr(3)%sendindex(i));   sr(3)%sendindex = 0
       if (associated(sre(p1)%sendindex)) then
         sr(3)%sendindex=sre(p1)%sendindex
         sr(3)%size_sendindex = i
       else
         sr(3)%size_sendindex = 0
       end if

       j = 1
       if (associated(sre(p1)%recvindex)) j = size(sre(p1)%recvindex)
       allocate(sr(3)%recvindex(j));   sr(3)%recvindex = 0
       if (associated(sre(p1)%recvindex)) then
          sr(3)%recvindex=sre(p1)%recvindex
          sr(3)%size_recvindex = j
       else
         sr(3)%size_recvindex = 0
       end if

    endif ! lmpi_nproc > 1

    do idata = 4,ndatalevel
       call lmpi_deallocate_sendrecv(idata)

      sr(idata)%sendrecv_allocated = .true.
      allocate(sr(idata)%sendproc(lmpi_nproc+1)); sr(idata)%sendproc  = 1
      allocate(sr(idata)%recvproc(lmpi_nproc+1)); sr(idata)%recvproc  = 1
      allocate(sr(idata)%sendindex(1));           sr(idata)%sendindex = 1
      allocate(sr(idata)%recvindex(1));           sr(idata)%recvindex = 1

    end do

  end subroutine lmpi_copy

#else
    use interp_defs, only : basic_sendrecv_type

    type (basic_sendrecv_type), dimension(:), intent(in) :: sr1, sre

  continue

    if (.false.) write(*,*) associated(sr1(1)%sendindex),                      &
                            associated(sre(1)%sendindex)

  end subroutine lmpi_copy

#endif

!-------------------------------------- START Private Parts -----
#ifdef HAVE_MPI

!============================ LMPI_DEALLOCATE_SENDRECV =======================80
!
! deallocate the sr send recieve arrays used by lmpi_xfer
!
!=============================================================================80

  subroutine lmpi_deallocate_sendrecv( lvl )

    integer, intent(in) :: lvl

    continue

    if (lmpi_nproc == 1) return ! for mpi with one proc
    if ( .not. sr_allocated ) return ! if the sr array is not allocated

    if (sr(lvl)%sendrecv_allocated) then
      sr(lvl)%sendrecv_allocated = .false.
      deallocate(sr(lvl)%sendproc)
      deallocate(sr(lvl)%recvproc)
      deallocate(sr(lvl)%sendindex)
      deallocate(sr(lvl)%recvindex)
    end if

    if (sr(lvl)%integr_mat_allocated) then
      sr(lvl)%integr_mat_allocated = .false.
      deallocate(sr(lvl)%integr_mat_senddata)
      deallocate(sr(lvl)%integr_mat_recvdata)
    end if

    if (sr(lvl)%integr_vec_allocated) then
      sr(lvl)%integr_vec_allocated = .false.
      deallocate(sr(lvl)%integr_vec_senddata)
      deallocate(sr(lvl)%integr_vec_recvdata)
    end if

    if (sr(lvl)%integ8_mat_allocated) then
      sr(lvl)%integ8_mat_allocated = .false.
      deallocate(sr(lvl)%integ8_mat_senddata)
      deallocate(sr(lvl)%integ8_mat_recvdata)
    end if

    if (sr(lvl)%integ8_vec_allocated) then
      sr(lvl)%integ8_vec_allocated = .false.
      deallocate(sr(lvl)%integ8_vec_senddata)
      deallocate(sr(lvl)%integ8_vec_recvdata)
    end if

    if (sr(lvl)%logicl_mat_allocated) then
      sr(lvl)%logicl_mat_allocated = .false.
      deallocate(sr(lvl)%logicl_mat_senddata)
      deallocate(sr(lvl)%logicl_mat_recvdata)
    end if

    if (sr(lvl)%logicl_vec_allocated) then
      sr(lvl)%logicl_vec_allocated = .false.
      deallocate(sr(lvl)%logicl_vec_senddata)
      deallocate(sr(lvl)%logicl_vec_recvdata)
    end if

    if (sr(lvl)%cmpxr8_mat_allocated) then
      sr(lvl)%cmpxr8_mat_allocated = .false.
      deallocate(sr(lvl)%cmpxr8_mat_senddata)
      deallocate(sr(lvl)%cmpxr8_mat_recvdata)
    end if

    if (sr(lvl)%cmpxr8_vec_allocated) then
      sr(lvl)%cmpxr8_vec_allocated = .false.
      deallocate(sr(lvl)%cmpxr8_vec_senddata)
      deallocate(sr(lvl)%cmpxr8_vec_recvdata)
    end if

    if (sr(lvl)%cmpxr4_mat_allocated) then
      sr(lvl)%cmpxr4_mat_allocated = .false.
      deallocate(sr(lvl)%cmpxr4_mat_senddata)
      deallocate(sr(lvl)%cmpxr4_mat_recvdata)
    end if

    if (sr(lvl)%cmpxr4_vec_allocated) then
      sr(lvl)%cmpxr4_vec_allocated = .false.
      deallocate(sr(lvl)%cmpxr4_vec_senddata)
      deallocate(sr(lvl)%cmpxr4_vec_recvdata)
    end if

    if (sr(lvl)%double_mat_allocated) then
      sr(lvl)%double_mat_allocated = .false.
      deallocate(sr(lvl)%double_mat_senddata)
      deallocate(sr(lvl)%double_mat_recvdata)
    end if

    if (sr(lvl)%double_vec_allocated) then
      sr(lvl)%double_vec_allocated = .false.
      deallocate(sr(lvl)%double_vec_senddata)
      deallocate(sr(lvl)%double_vec_recvdata)
    end if

    if (sr(lvl)%single_mat_allocated) then
      sr(lvl)%single_mat_allocated = .false.
      deallocate(sr(lvl)%single_mat_senddata)
      deallocate(sr(lvl)%single_mat_recvdata)
    end if

    if (sr(lvl)%single_vec_allocated) then
      sr(lvl)%single_vec_allocated = .false.
      deallocate(sr(lvl)%single_vec_senddata)
      deallocate(sr(lvl)%single_vec_recvdata)
    end if

  end subroutine lmpi_deallocate_sendrecv

!================================== add_logical ==============================80
!
! adds logicals by or'ing them
!
!=============================================================================80

  function add_logical(l1, l2)
    logical, intent(in) :: l1, l2
    logical             :: add_logical

    continue

    add_logical = ( l1 .or. l2 )

  end function add_logical


!============================== multiply_logical_logical =====================80
!
! multiplys logicals by and'ing them
!
!=============================================================================80

  function multiply_logical_logical(l1, l2)
    logical, intent(in) :: l1, l2
    logical             :: multiply_logical_logical

    continue

    multiply_logical_logical = ( l1 .and. l2 )

  end function multiply_logical_logical


!============================== multiply_single_logical ======================80
!
! multiplys singles and logicals with magic
!
!=============================================================================80

  function multiply_single_logical(l1, l2)
    real(system_r4), intent(in) :: l1
    logical,         intent(in) :: l2
    logical                     :: multiply_single_logical

    continue

    multiply_single_logical = .false.
    if (l2) then
       write(*,*) 'lmpi_app::multiply_single_logical: should never occur.'
       write(*,*) 'l1,l2 = ',l1,l2
       stop ! FIXME: should be lmpi_die?
    end if

  end function multiply_single_logical


!============================== multiply_double_logical ======================80
!
! multiplys doubles and logicals with magic
!
!=============================================================================80

  function multiply_double_logical(l1, l2)
    real(system_r8), intent(in) :: l1
    logical,         intent(in) :: l2
    logical                     :: multiply_double_logical

    continue

    multiply_double_logical = .false.
    if (l2) then
       write(*,*) 'lmpi_app::multiply_double_logical: should never occur.'
       write(*,*) 'l1,l2 = ',l1,l2
       stop ! FIXME: should be lmpi_die?
    end if

  end function multiply_double_logical


!========================== multiply_complex_r4_logical ======================80
!
! multiplys complex_r4s and logicals with magic
!
!=============================================================================80

  function multiply_complex_r4_logical(l1, l2)
    complex(system_r4), intent(in) :: l1
    logical,            intent(in) :: l2
    logical                     :: multiply_complex_r4_logical

    continue

    multiply_complex_r4_logical = .false.
    if (l2) then
       write(*,*) 'lmpi_app::multiply_complex_r4_logical: should never occur.'
       write(*,*) 'l1,l2 = ',l1,l2
       stop ! FIXME: should be lmpi_die?
    end if

  end function multiply_complex_r4_logical


!========================== multiply_complex_r8_logical ======================80
!
! multiplys complex_r8s and logicals with magic
!
!=============================================================================80

  function multiply_complex_r8_logical(l1, l2)
    complex(system_r8), intent(in) :: l1
    logical,            intent(in) :: l2
    logical                     :: multiply_complex_r8_logical

    continue

    multiply_complex_r8_logical = .false.
    if (l2) then
       write(*,*) 'lmpi_app::multiply_complex_r8_logical: should never occur.'
       write(*,*) 'l1,l2 = ',l1,l2
       stop ! FIXME: should be lmpi_die?
    end if

  end function multiply_complex_r8_logical


!================================== max_logical ==============================80
!
! max's logicals by or'ing them
!
!=============================================================================80

  function max_logical(l1, l2)
    logical, intent(in) :: l1, l2
    logical             :: max_logical

    continue

    max_logical = ( l1 .or. l2 )

  end function max_logical


!================================== max_complex_r4 ===========================80
!
! max's complex r4 by maxing the real parts
!
!=============================================================================80

  function max_complex_r4(c1, c2)
    complex(system_r4), intent(in) :: c1, c2
    complex(system_r4)             :: max_complex_r4

    continue

    if( real(c1,system_r4) > real(c2,system_r4) ) then
      max_complex_r4 = c1
    else
      max_complex_r4 = c2
    endif

  end function max_complex_r4


!================================== max_complex_r8 ===========================80
!
! max's complex r8 by maxing the real parts
!
!=============================================================================80

  function max_complex_r8(c1, c2)
    complex(system_r8), intent(in) :: c1, c2
    complex(system_r8)             :: max_complex_r8

    continue

    if( real(c1,system_r8) > real(c2,system_r8) ) then
      max_complex_r8 = c1
    else
      max_complex_r8 = c2
    endif

  end function max_complex_r8

#endif
!-------------------------------------- START Private Parts -----

end module lmpi_app
